


function ChatManager() {
    //var header = $('#header');
    //var rooms = $('#rooms');
    //var content = $('#content');
    this.users = [];
    this.myName = '';
    this.author = '';
    this.logged = false;
    this.socket = atmosphere;
    this.subSocket;
    this.transport = 'websocket';
    this.fallbackTransport = 'long-polling';
    this.connected = false;
    this.uuid = 0;
	var self = this;
	
	this.chatMsg = { author   : '',
	                msg      : '',
					dateTime : ''	
					};
					
	this.chatMsgsMap = new Map();
	
	this.initChat = function(){
		if (!this.connected){
			this.connected = true;
			this.myName = getChatUserId(appUser.user.username);
			this.author = getChatUserId(appUser.user.username);
			this.logged = true;
			//alert('11');
			this.connectToChatRoom('pth');
			//setTimeout(function(){
			//	self.subSocket.push(atmosphere.util.stringifyJSON({ author: self.author, message: self.author, uuid: self.uuid }));
			//	},4000);
		}
		
	}
	
	this.logOutChat = function(){
		self.socket.unsubscribe();
		self.author = '';
	}
	
	this.isUserOnline = function(userId){
		if (this.users != null){
			for (var i = 0; i < this.users.length; i++) {
				if (userId == this.users[i]){
					return true;
				}
            }
		}
		return false;
	}
	
	this.addChatMsg = function(key,mgs){
		//alert('00');
		var chatMsgs = this.chatMsgsMap.get(key);
		if (chatMsgs == null){
			chatMsgs = [];
		}
		chatMsgs.push(mgs);
		this.chatMsgsMap.put(key,chatMsgs);
		
		this.handleMessage(key,mgs);
	}
	
	this.sendChatMessage = function(tgtUser,msg, includeFrom, send){	
		//msg = msg.replace(/([:|\[\]\/\\])/g, "");
		//alert('llld');
		if (msg.trim().length == 0){
			return;
		}
		var createDtTm = new Date();
		if (includeFrom == true){
			this.addChatMsg(tgtUser,{ author   : self.author,
								      msg      : msg,
								      dateTime : createDtTm
								    }
							);
		}
		
		if (send != undefined && send == false){ // Don't send the message now
			return createDtTm.getTime();
		}
		
		try{
			self.subSocket.push(atmosphere.util.stringifyJSON({ user: tgtUser, message: self.author+':::'+msg}));
		}catch(e){
			self.connectToChatRoom('pth');
			setTimeout(function(){
				self.subSocket.push(atmosphere.util.stringifyJSON({ user: tgtUser, message: self.author+':::'+msg}));
			},5000);
		}
	}
	
	this.recievedChatMessage = function(fromUser,msg, dateTime){
		
		$('#chatSendMsgTxtInputNotification').hide();
		
		if (msg.indexOf('**pvtMsg**') != 0){
			return;
		}
		
		if (msg.indexOf('**typing**') > 0){
			$('#chatSendMsgTxtInputNotification').show();
			setTimeout(function() { $('#chatSendMsgTxtInputNotification').hide(); }, 3000);
			return;
		}
		
		msg = msg.replace('**pvtMsg**','');
		this.addChatMsg(fromUser,{ author   : fromUser,
							 msg      : msg,
							 dateTime : dateTime	
							});
	}
	
	
	
	// Handles all the messages. 
	this.handleMessage = function(tgtUser, message) { 
		var screenWidth = Math.min(viewport.width,viewport.height);
		try{
			var msgType = (message.msg.indexOf('**Img**') >=0?'img':'txt');
			
			if (gChatScope != null){
				//handle multiChat window
				var chatUser = null;
				angular.forEach(gChatScope.chatUsers, function(v) {
					if (tgtUser == v.userChatUserId){
						chatUser = v;
					}else if ( message.author == v.userChatUserId){
						chatUser = v;
					}					
				});
				
				if (chatUser != null){ // got the link, so update that 
					chatUser.lastChatDtTm = message.dateTime;
					chatUser.lastChatMsg = message.msg.replace('**Img**','');
					chatUser.lastChatMsgAuthor = (message.author == self.myName?'You : ':'');
					chatUser.lastChatMsgType = msgType;
					
					chatUser.lastChatMsgCls = ((message.author==gChatScope.chat.tgtUser || tgtUser==gChatScope.chat.tgtUser)?'lastChatMsgCls':'lastChatMsgBldCls');
					
					if (message.author != self.myName){ // if author is someone else then only that's unread for me.
						chatUser.online = true;
						chatUser.unreadMsgCnt = chatUser.unreadMsgCnt + 1;
						gChatScope.logedInUser.unreadMsgCnt = (parseInt(gChatScope.logedInUser.unreadMsgCnt)|0) + 1;
					}
					
				}
				
				if (message.author==gChatScope.chat.tgtUser || tgtUser==gChatScope.chat.tgtUser){
					gChatScope.chatMsgs.push ({create_dt: message.dateTime,
											   msgType: msgType,
											   msg: message.msg.replace('**Img**',''),
											   author: (message.author == self.myName?'me':message.author),
											   authorProfPicSrc:(message.author == self.myName?appUser.user.profPicSrc:gTgtUserProfilePic),
											   from_user_id: message.author,
											   tgt_user_id: tgtUser,
											   id: message.dateTime.getTime()
											   });
					
					if (chatUser != null){ // got the link, so update that 
						chatUser.unreadMsgCnt = 0;
					}
					
					gChatScope.logedInUser.unreadMsgCnt = 0;
					angular.forEach(gChatScope.chatUsers, function(v) {
						gChatScope.logedInUser.unreadMsgCnt = (parseInt(gChatScope.logedInUser.unreadMsgCnt)|0) + (parseInt(v.unreadMsgCnt)|0);
					});
					if (message.author != self.myName){ // if author is someone else then only that's unread for me.
						getHTTPRequest( imgRootURL + 'executeService?service=chatStatusUpdate&between=' + self.myName+';'+ message.author +
													 '&status=R',
											function(data) {
												if (data == 'null') return;												
											}
									   );
					}							  
					
				}else{
					playChatNotification();
				}
				
				gChatScope.$apply();
			}else{
				playChatNotification();
			}
			
			setTimeout(function(){
				gIndvChatIonicScrollDelegate.resize();
				gIndvChatIonicScrollDelegate.scrollBottom();
			},100);
			
			
			
			return;
		
			var msgSpanStr = null;
			if (message.author == this.myName){
				msgSpanStr ="<span style='clear:both;width:100%'> " +
								"<span class='comment right wrap' style='float:left;width:81%;margin-top:-5px'> " 
									+ (message.msg.indexOf('**Img**') == 0? 
										//"<pth-image-gal image='"+ message.msg.replace('**Img**','') + "' h='" + screenWidth*0.70 +"' w='" + screenWidth*0.70 +"' imgcls='pthImg' ></pth-image-gal>"	:
										"<img src='"+ message.msg.replace('**Img**','') + "' height='" + screenWidth*0.70 +"' width='" + screenWidth*0.70 +"' />"	:
										message.msg)  +
									"<span class='chatDtTimeCss'>" + chatMsgDtTime(message.dateTime) + "</span> " +
								"</span> " +
								"<span style='float:right;margin-right:5px;'> " +
									"<img src='" + appUser.user.profPicSrc  +"' height='40px' width='40px' class='profile-img'/> " +
								"</span>" +									
							"</span>";					
			}else{
				msgSpanStr ="<span style='clear:both;width:100%'> " +
								"<span style='float:left;margin-left:5px;'> " +
									"<img src='" + gTgtUserProfilePic  +"' height='40px' width='40px' class='profile-img'/> " +
								"</span>" +	
								"<span class='comment left wrap' style='float:left;width:78%;margin-top:-5px'> " 
									+ (message.msg.indexOf('**Img**') == 0? 
										//"<pth-image-gal image='"+ message.msg.replace('**Img**','') + "' h='" + screenWidth*0.70 +"' w='" + screenWidth*0.70 +"' imgcls='pthImg' ></pth-image-gal>"	:
										"<img src='"+ message.msg.replace('**Img**','') + "' height='" + screenWidth*0.70 +"' width='" + screenWidth*0.70 +"' />"	:
										message.msg)  +
									"<span class='chatDtTimeCss'>" + chatMsgDtTime(message.dateTime) + "</span> " +
								"</span> " +
							"</span>";			
			}
			
			var messageEl = $("<li style='clear:both;width:100%;padding-top:8px;'>" + msgSpanStr + "</li>");
			//var messageEl = $("<li style='clear:both;width:100%;padding-top:8px;'>" + msgSpanStr + "</li>"); 
			$('#chatMsgContent' + tgtUser).append(messageEl); 
			//$('#chatMsgContent' + tgtUser).listview('refresh'); 
			gIndvChatIonicScrollDelegate.scrollBottom();
			
			
			// Scroll to bottom of page 
			//$('#chatMsgContent' + tgtUser).
			//$("html, body").animate({ scrollTop: $(document).height() - $(window).height() }, 'slow'); 
		}catch(e){
			alert(e);
		}
	}
	
	this.heartBitInterval = setInterval(function() {
		try{
			if (self.author != ''){
				self.subSocket.push(atmosphere.util.stringifyJSON({ author: self.author, message: '**entered room**' + self.author, uuid: self.uuid }));
			}
			
		}catch(e){}
		}, 60 * 1000); 
	
	
	
	this.connectToChatRoom = function(chatroom) {
		//alert('22');
        // We are now ready to cut the request
        var request = {url: 'http://174.143.120.136:9191/pthChat/chat/' + chatroom,
			//url: 'http://localhost:8080/pthChat/chat/' + chatroom,
            contentType: "application/json",
            logLevel: 'debug',
            transport: this.transport,
            trackMessageLength: true,
            reconnectInterval: 5000,
            fallbackTransport: this.fallbackTransport};

        request.onOpen = function (response) {
			//alert('55');
            //content.html($('<p>', { text: 'Atmosphere connected using ' + response.transport }));
            //status.text('Choose name:');
            //input.removeAttr('disabled').focus();
            self.transport = response.transport;
            self.uuid = response.request.uuid;
			//alert ('self.uuid ' + self.uuid + '  ' + self.subSocket);
			self.subSocket.push(atmosphere.util.stringifyJSON({ author: self.author, message: '**entered room**' + self.author, uuid: self.uuid }));
        };

        request.onReopen = function (response) {
            //content.html($('<p>', { text: 'Atmosphere re-connected using ' + response.transport }));
            //input.removeAttr('disabled').focus();
			
			//alert('llla');
			
        };

        request.onMessage = function (response) {
			//alert('lll');
            var message = response.responseBody;
            try {
                var json = atmosphere.util.parseJSON(message);
            } catch (e) {
                console.log('This doesn\'t look like a valid JSON: ', message);
                return;
            }

            /*
			input.removeAttr('disabled').focus();
            if (json.rooms) {
                rooms.html($('<h2>', { text: 'Current room: ' + chatroom}));

                var r = 'Available rooms: ';
                for (var i = 0; i < json.rooms.length; i++) {
                    r += json.rooms[i] + "  ";
                }
                rooms.append($('<h3>', { text: r }))
            }
			*/

            if (json.users) {
				self.users = json.users;
				
				if (gChatScope != null){
					angular.forEach(gChatScope.chatUsers, function(v) {
						if (self.users.indexOf(v.userChatUserId) >= 0){
							v.online = true;
						}else{
							v.online = false;
						}									
					});
					gChatScope.$apply();
				}
				
				/*
                var r = 'Connected users: ';
                for (var i = 0; i < json.users.length; i++) {
                    r += json.users[i] + "  ";
                }
                users.html($('<h3>', { text: r }))
				*/
            }

            if (json.author) {
                if (!this.logged && this.myName) {
                    this.logged = true;
                    //status.text(myName + ': ').css('color', 'blue');
                } else {
                    var me = json.author == self.author;
                    var date = typeof(json.time) == 'string' ? parseInt(json.time) : json.time;
                    //addMessage(json.author, json.message, me ? 'blue' : 'black', new Date(date));
					self.recievedChatMessage(json.author, json.message, new Date(date));
                }
            }
        };

        request.onClose = function (response) {
            self.subSocket.push(atmosphere.util.stringifyJSON({ author: self.author, message: '**disconnecting**' }));
			self.connected = false;
			self.logged = false;
        };

        request.onError = function (response) {
			//alert('44');
            //content.html($('<p>', { text: 'Sorry, but there\'s some problem with your ' + 'socket or the server is down' }));
            self.logged = false;
			
        };

        request.onReconnect = function (request, response) {
            //content.html($('<p>', { text: 'Connection lost, trying to reconnect. Trying to reconnect ' + request.reconnectInterval}));
            //input.attr('disabled', 'disabled');
			
			//gIonicLoading.show({template: 'Chat Connection re-opening with UUIds : ' + self.uuid + ' && ' + response.request.uuid, duration: 2000});
			self.uuid = response.request.uuid;
			self.connected = true;
			self.logged = true;
			self.subSocket.push(atmosphere.util.stringifyJSON({ author: self.author,  message: "**entered room** " + self.author, uuid: self.uuid }));
			
			
        };
		//alert('33');
		try{
			self.subSocket = self.socket.subscribe(request);
		}catch(eee){
			//alert('error :' + eee);
		}
		
		//alert('333');
    }

}

var chatManger = new ChatManager();	
	
	

    //header.html($('<h3>', { text: 'Atmosphere Chat. Default transport is ' + transport + ', fallback is ' + fallbackTransport }));
   // status.text('Choose chatroom:');
    /*input.removeAttr('disabled').focus();

    input.keydown(function (e) {
        if (e.keyCode === 13) {
            var msg = $(this).val();

            $(this).val('');
            if (!connected) {
                connected = true;
                connect(msg);
                return;
            }

            // First message received is always the author's name
            if (author == null) {
                author = msg;
            }

            input.removeAttr('disabled').focus();
            // Private message
            if (msg.indexOf(":") !== -1) {
                var a = msg.split(":")[0];
				var b = msg.split(":")[1];
                subSocket.push(atmosphere.util.stringifyJSON({ user: a, message: author+':'+b}));
            } else {
                subSocket.push(atmosphere.util.stringifyJSON({ author: author, message: msg, uuid: uuid }));
            }

            if (myName === false) {
                myName = msg;
            }
        }
    });

    */
    function addMessage(author, message, color, datetime) {
        content.append('<p><span style="color:' + color + '">' + author + '</span> @ ' + +(datetime.getHours() < 10 ? '0' + datetime.getHours() : datetime.getHours()) + ':'
            + (datetime.getMinutes() < 10 ? '0' + datetime.getMinutes() : datetime.getMinutes())
            + ': ' + message + '</p>');
    }

	function chatMsgDtTime(datetime){
	
		return gAngularFilter('date')(datetime,'MMM d, y h:mm:ss a');
	
		/*
		return (datetime.getHours() < 10 ? '0' + datetime.getHours() : (datetime.getHours() > 12 ? '0' + (datetime.getHours()-12):datetime.getHours())) + ':'
            + (datetime.getMinutes() < 10 ? '0' + datetime.getMinutes() : datetime.getMinutes()) + ' '
			+ (datetime.getHours() > 11 ? 'PM' : 'AM');
		*/
	}
	
	function getChatUserId(userId){
		return userId.replace(/([.@*+?^=!:${}()|\[\]\/\\])/g, "");
	}

	
	