

controllers.controller('multiChatCtrl', ['$scope', '$state', '$http',  'ApgeeService','$ionicSlideBoxDelegate','$ionicScrollDelegate','$timeout','$ionicLoading','$ionicModal','$ionicPopup',
	
	function($scope, $state, $http, ApgeeService, $ionicSlideBoxDelegate, $ionicScrollDelegate, $timeout, $ionicLoading, $ionicModal,$ionicPopup) {
		
		$scope.pthFriends = [];
		$scope.chatUsers = [];
		$scope.chatMsgs = [];
		$scope.chat = 	  { author: '',
							chatSendMsgTxt: '',
							tgtUser: '',
							tgtUserId: '',
							tgtUserProfilePic: '',
							tgtUserNm: '',
							isFrnd: true
						  };
		
		$scope.chatUserIndex = -1;
		$scope.screenWidth = Math.min(viewport.width,viewport.height);
		
		gChatScope = $scope;
		
		
		$scope.initChatCntl = function(){
			if (appUser == undefined || appUser == null) return;
			
			$scope.pthFriends.length = 0;
			$scope.chatUsers.length = 0;
			
			$scope.logedInUser.unreadMsgCnt = 0;
			
			//showBusy(true);
			getHTTPRequest( imgRootURL + 'executeService?service=chatMsgsFrndList&userId=' + appUser.user.username,
						    function(data) {
								if (data == 'null') return;
								if (angular.isArray(data)){
									angular.forEach(data, function(value, key){
										if (value.last_chat_msg_dt != null && value.last_chat_msg_dt.length > 0){
											value.last_chat_msg_dt = parseUTCStrToDate(value.last_chat_msg_dt);
										}
										var msgs = value.last_chat_msg.split(':::');
										var lastChatMsg, lastChatMsgCls, lastChatMsgType, lastChatMsgAuthor;
										lastChatMsgCls = 'lastChatMsgCls';
										
										if (msgs.length == 3) {// good
											if (getChatUserId(appUser.user.username) == msgs[0]){
												lastChatMsgAuthor = 'You : ' ;
												lastChatMsg = msgs[1];
											}else{
												//lastChatMsgAuthor = value.full_name.split(' ')[0];
												lastChatMsgAuthor = '';
												lastChatMsg = msgs[1];
												if (msgs[2] != 'R'){
													lastChatMsgCls = 'lastChatMsgBldCls';
												}
											}
										}
										lastChatMsgType = (lastChatMsg.indexOf('**Img**') >=0?'img':'txt');
										$scope.chatUsers.push({
																username: value.userid,
																userChatUserId: getChatUserId(value.userid),
																fullName: value.full_name,
																profPic: value.url,
																lastChatDtTm: value.last_chat_msg_dt,
																lastChatMsg: lastChatMsg.replace('**Img**',''),
																lastChatMsgCls: lastChatMsgCls,
																lastChatMsgType: lastChatMsgType,
																lastChatMsgAuthor: lastChatMsgAuthor,
																online: chatManger.isUserOnline(getChatUserId(value.userid)),
																unreadMsgCnt: parseInt(value.unread_chat_msg_cnt)|0
															   });	

										$scope.logedInUser.unreadMsgCnt = (parseInt($scope.logedInUser.unreadMsgCnt)|0) + ( parseInt(value.unread_chat_msg_cnt)|0);
									});									
								}
								
								
								
								
							}
						);
		
			
		
		}
		
		
		$scope.getFreindList = function(sucessHandler){		
			getHTTPRequest( imgRootURL + 'getHotties?userid=' + appUser.user.username+'&status=AFR',
						    function(data) {
								if (data == 'null') return;
								var datas = [];
								if (angular.isArray(data.hottie)){
									angular.forEach(data.hottie, function(value, key){
										value.url = hottieImgBaseUrl + value.picId + '.jpg'; 
										value.picWinPct = getWinPercentage(value.wins,value.losses);
										this.push(value);										
									}, datas);
								}else{
									data.hottie.url = hottieImgBaseUrl + data.hottie.picId + '.jpg';
									data.hottie.picWinPct = getWinPercentage(data.hottie.wins,data.hottie.losses);
									datas.push(data.hottie);									
								}
								$scope.pthFriends = datas;	
								//alert('cc ' + $scope.pthFriends.length);
								sucessHandler();
							}
						);
		}
		
		$ionicModal.fromTemplateUrl('templates/indvChatNew.html', {
			id: 'indvChatModal',
			scope: $scope,
			backdropClickToClose: false,
			hardwareBackButtonClose: false,
			animation: 'slide-in-right'
		  }).then(function(modal) {
			$scope.indvChatModal = modal;
		});	
		
		
		$scope.openIndvChatModal = function(chatUser, indx){	
			try{
				//alert('a ' + chatUser.username);
				$scope.chat.author = '';
				$scope.chat.chatSendMsgTxt = '';
				$scope.chat.tgtUser = getChatUserId(chatUser.username);
				$scope.chat.tgtUserId = chatUser.username;
				$scope.chat.tgtUserProfilePic = chatUser.profPic;
				$scope.chat.tgtUserNm = chatUser.fullName;
				$scope.chat.isFrnd = true;
				
				$scope.chatUserIndex = indx;			
				gTgtUserProfilePic = $scope.chat.tgtUserProfilePic;
				$scope.$broadcast("triggerGetChatMessages", {});
				//$scope.getChatMessages();
				$scope.indvChatModal.show();
			}catch(e){
				alert(e);
			}
		}
		
		
		
		
		
		$scope.closeIndvChatModal = function(){
			$scope.chat.author = '';
			$scope.chat.chatSendMsgTxt = '';
			$scope.chat.tgtUser = '';
			$scope.chat.tgtUserId = '';
			$scope.chat.tgtUserProfilePic = '';
			$scope.chat.tgtUserNm = '';
								
			$scope.indvChatModal.hide();
		}
		
		
		
		
		
		
		$scope.$on('$destroy', function() {
			try{$scope.indvChatModal.remove();}catch(e){}			
		});
	
	
		$scope.$on("initChatCntl", function (event, args) {
			$scope.initChatCntl();
		});
	
		
		
}]);

controllers.controller('chatCtrl', ['$scope', '$state', '$http',  'ApgeeService','$ionicSlideBoxDelegate','$ionicScrollDelegate','$timeout','$ionicLoading','$ionicModal','$ionicPopup', '$ionicActionSheet',
	
	function($scope, $state, $http, ApgeeService, $ionicSlideBoxDelegate, $ionicScrollDelegate, $timeout, $ionicLoading, $ionicModal,$ionicPopup, $ionicActionSheet) {
	
		gIndvChatIonicScrollDelegate = $ionicScrollDelegate.$getByHandle('indvChatContentDelegate');
		
		$scope.chatMsgTypingLetterCnt = 0;
		$scope.btnShow = 'sendChatAttahmentImg';
		
		
		
		$scope.chatMsgs = gChatScope.chatMsgs;
		$scope.chat = gChatScope.chat;
		
		$scope.getChatMessages = function(sucessHandler){
			//alert('1');
			$scope.chatMsgs.length = 0;
			showBusy(true);
			getHTTPRequest( imgRootURL + 'executeService?service=getChatMsgs&between=' + getChatUserId(appUser.user.username)+';'+ getChatUserId($scope.chat.tgtUserId),
						    function(data) {
								if (data == 'null') return;
								//alert('2');
								if (angular.isArray(data)){
									angular.forEach(data, function(value, key){
										value.create_dt = parseUTCStrToDate(value.create_dt);
										if (getChatUserId(appUser.user.username) == value.from_user_id){
											value.author = 'me';
											value.authorProfPicSrc = appUser.user.profPicSrc;
										}else{
											value.author = value.from_user_id;
											value.authorProfPicSrc = $scope.chat.tgtUserProfilePic;
										}
										value.msgType = 'txt';
										value.msg = value.msg.replace('The Hottie:','The Hottie');
										if (value.msg.indexOf('**Img**') > -1){
											value.msgType = 'img';
											value.msg = value.msg.replace('**Img**','');
										}
										//insertAt($scope.chatMsgs,0,value);
										//alert('3');
										insertAt($scope.chatMsgs,0,value);
										
									});								
								}
								//alert('4');
								//showBusy(false);
								
								$timeout(function () {
									//alert('6');
									gIndvChatIonicScrollDelegate.scrollBottom();
									showBusy(false);
									//alert('7');
									getHTTPRequest( imgRootURL + 'executeService?service=chatStatusUpdate&between=' + getChatUserId(appUser.user.username)+';'+ getChatUserId($scope.chat.tgtUserId) +
																 '&status=R',
													function(data) {
														if (data == 'null') return;
														//alert('8');
														if(data[0].updateCnt > 0){
															$('#chatFrndListLastMsg_' + getChatUserId($scope.chat.tgtUserId)).removeClass("lastChatMsgBldCls").addClass("lastChatMsgCls");
															
															if ($scope.chatUserIndex >=0){
																$scope.chatUsers[$scope.chatUserIndex].unreadMsgCnt = 0;
																$scope.logedInUser.unreadMsgCnt = 0;
																angular.forEach($scope.chatUsers, function(v) {
																	$scope.logedInUser.unreadMsgCnt = (parseInt($scope.logedInUser.unreadMsgCnt)|0) + (parseInt(v.unreadMsgCnt)|0);
																});
															}
															
														}
													}
												  );
								},1000);
								
								//alert('5');
								
							}
						);
		}
		
		
		
		
		
		
		$scope.loadMoreChatMsgs = function(){		
			//var scrollBefore = document.getElementById('content').scrollHeight;
			
			var chatId = 0;
			if ($scope.chatMsgs.length > 0){
				chatId = parseInt($scope.chatMsgs[0].id)|0;
			}
			
			if (chatId <= 0){
				$scope.$broadcast('scroll.refreshComplete');
				return;
			}
			
			getHTTPRequest( imgRootURL + 'executeService?service=getChatMsgs&between=' + getChatUserId(appUser.user.username)+';'+ getChatUserId($scope.chat.tgtUserId) +
							'&chatId='+ chatId,
						    function(data) {
								if (data == 'null') return;
								var chatMsgs = [];
								if (angular.isArray(data)){
									angular.forEach(data, function(value, key){
										value.create_dt = new Date(value.create_dt.replace(' ','T'));
										if (getChatUserId(appUser.user.username) == value.from_user_id){
											value.author = 'me';
											value.authorProfPicSrc = appUser.user.profPicSrc;
										}else{
											value.author = value.from_user_id;
											value.authorProfPicSrc = $scope.chat.tgtUserProfilePic;
										}
										value.msgType = 'txt';
										value.msg =  value.msg.replace('The Hottie:','The Hottie');
										if (value.msg.indexOf('**Img**') > -1){
											value.msgType = 'img';
											value.msg = value.msg.replace('**Img**','');
										}
										//chatMsgs.push(value);
										insertAt(chatMsgs,0,value);
									});
								}
								
								if (chatMsgs.length > 0){
									insertArrayAt($scope.chatMsgs, 0, chatMsgs);
								}
								
								$scope.$broadcast('scroll.refreshComplete');
								// scroll to the previous spot
								  $timeout(function () {
									//var scrollAfter = document.getElementById('content').scrollHeight;
									//$ionicScrollDelegate.scrollTo(0, scrollAfter-scrollBefore, false);
								  }, 200);
  
								//setTimeout(function(){
								//	$scope.$broadcast('scroll.refreshComplete');
								//	$scope.$broadcast('scroll.resize');
								//	$scope.$broadcast('scroll.resize');
								//},1000);
								
							}
						 );
		
		}
		
		$scope.sendChatMsg = function(){
			chatManger.sendChatMessage($scope.chat.tgtUser,$scope.chat.chatSendMsgTxt, true);
			$scope.chat.chatSendMsgTxt = '';
			$scope.chatMsgTypingLetterCnt = 0;
			//$('#sendChatMsgImg').hide();
			//$('#sendChatAttahmentImg').show();
			$scope.btnShow = 'sendChatAttahmentImg';
		}
	
	
		$scope.$watch('chat.chatSendMsgTxt', function (now, then) {
			//if (now && now.length) {
			
				$scope.chatMsgTypingLetterCnt = now.length;
				if ($scope.chatMsgTypingLetterCnt > 3){
					chatManger.sendChatMessage($scope.chat.tgtUser, appUser.user.name.split(' ')[0] + ' **typing**', false);
					$scope.chatMsgTypingLetterCnt = 0;
				}
				
				if (now.length < 1){ //show attachment icon
					$scope.btnShow = 'sendChatAttahmentImg';
					//$('#sendChatAttahmentImg').show();
				}else{// show send icon
					$scope.btnShow = 'sendChatMsgImg';
					//$('#sendChatMsgImg').show();
				}
				
			//}
			
		});
	
		$scope.typingChatMsg = function(eve){
			return;
			
			$scope.chatMsgTypingLetterCnt++;
			if ($scope.chatMsgTypingLetterCnt > 3){
				chatManger.sendChatMessage($scope.chat.tgtUser, appUser.user.name.split(' ')[0] + ' **typing**', false);
				$scope.chatMsgTypingLetterCnt = 0;
			}
			var enteredCharLngth = $scope.chat.chatSendMsgTxt.length;
			if (eve.keyCode === 8) {
				enteredCharLngth = enteredCharLngth - 1;
			}else{
				enteredCharLngth = enteredCharLngth + 1;
			}
			//$('#sendChatMsgImg').hide();
			//$('#sendChatAttahmentImg').hide();
			
			if (enteredCharLngth < 1){ //show attachment icon
				$scope.btnShow = 'sendChatAttahmentImg';
				//$('#sendChatAttahmentImg').show();
			}else{// show send icon
				$scope.btnShow = 'sendChatMsgImg';
				//$('#sendChatMsgImg').show();
			}
		
		}
		
		$scope.onChatMsgInputFocus = function(focus){
			$ionicScrollDelegate.$getByHandle('indvChatContentDelegate').scrollBottom();
		}
		
		
		$scope.openUrl = function(url){
			//alert(url);
			window.open(url, '_blank', 'location=no,closebuttoncaption=Close');
		}
		
		$ionicModal.fromTemplateUrl('templates/fullScreenImg.html', {
			id: 'fullScreenImgModal',
			scope: $scope,
			backdropClickToClose: true,
			hardwareBackButtonClose: true,
			animation: 'slide-in-right'
		  }).then(function(modal) {
			$scope.fullScreenImgModal = modal;
		});	
		
		$scope.closeFullScrnImgModal = function(){
			$scope.fullScreenImgModal.hide();		
		};
		
		$scope.openFullScrnImgModal = function(url){
			$scope.imgUrl = url;
			$scope.fullScreenImgModal.show();
		}
		
		$scope.showSendChatFileOptions = function(){
			var hideSheet = $ionicActionSheet.show({
				 buttons: [
						   { text: 'Add from Library' },
						   { text: 'Take Photo' }
						  ],			
				 cancel: function() {
					  hideSheet();
					},
				 buttonClicked: function(index) {
					if (index == 0){			
						$scope.sendPhotoGalaryImg();
					}else{
						$scope.sendCameraTakenImg();
					}
				   return true;
				 }
				});
		}
		
		$scope.sendCameraTakenImg = function(){			
			try{
				 navigator.camera.getPicture(function(imageURI) {
					var id = chatManger.sendChatMessage($scope.chat.tgtUser, '**Img**' + imageURI, true, false);
					$scope.uploadPicturetToPTHServer(imageURI, id);					
				}, function(err) {

				}, {
					quality: 100,
					targetWidth: 760,
					targetHeight: 760,
					saveToPhotoAlbum: false				
				});
			}catch(e){
				alert(e);
			}
		  
		
		}
		
		$scope.sendPhotoGalaryImg = function(){			
			try{
				 navigator.camera.getPicture(function(imageURI) {
					var id = chatManger.sendChatMessage($scope.chat.tgtUser, '**Img**' + imageURI, true, false);
					$scope.uploadPicturetToPTHServer(imageURI, id);					
				}, function(err) {

				}, {
					quality: 100,
					targetWidth: 760,
					targetHeight: 760,
					destinationType: 1, 
					sourceType: 0 			
				});
			}catch(e){
				alert(e);
			}
		  
		
		}
		
		$scope.fileTrnsferPerc = 0;
		
		$scope.uploadPicturetToPTHServer = function(fileURL, id) {
			$ionicLoading.show({template: 'Sending....' });
			
			var options = new FileUploadOptions();
			options.fileKey = "file";
			options.fileName = getChatUserId(appUser.user.username) + '_' + new Date().getTime() + ".jpg";
			options.mimeType = "image/jpeg";
			options.chunkedMode = true;						  

			options.params = {userName       : appUser.user.username,
							  calledFor      : 'CHAT_MSG',
						      faceDetect     : 'false'};

			var ft = new FileTransfer();
			ft.onprogress = function(progressEvent) {
				if (progressEvent.lengthComputable) {
					var perc = Math.floor(progressEvent.loaded / progressEvent.total * 100);
					$scope.fileTrnsferPerc = perc;	
					progress(($scope.fileTrnsferPerc > 50?$scope.fileTrnsferPerc-5:$scope.fileTrnsferPerc), $('#progressBar_' + id));					
				} else {
					//$scope.fileTrnsferPerc++;
				}
				
			};
			$scope.fileTrnsferPerc = 0;
			$('#progressBar_' + id).show();
			ft.upload(fileURL, 
					    encodeURI(imgRootURL +'uploadPics'), 
					    function(sucess) {					
							progress(100, $('#progressBar_' + id));
							$timeout(function(){$('#progressBar_' + id).hide();},1000);
							
							$ionicLoading.hide();
							
							var retCd = getValueByRegExp(sucess.response,'returnCd')[0];
							if (retCd == 'R'){ // rejected
								var alertPopup = $ionicPopup.alert({
																	 title: 'Image Upload Rejected',
																	 template: getValueByRegExp(sucess.response,'returnMsg')[0]
																   });
								$timeout(function(){$(".popup").css("width", "60%");},100);
								
							}else{																	
								var imageId = getValueByRegExp(sucess.response,'file')[0];
								//$ionicLoading.show({template: 'imageId : ' + imageId, duration: 2000});
								chatManger.sendChatMessage($scope.chat.tgtUser, '**Img**' + hottieImgBaseUrl + imageId, false, true);
								
							}
							
							
						}, 
						function(error) {
							$ionicLoading.show({template: 'Error in Sending File...', duration: 5000});
							
						}, 
						options);
		}
		
		$scope.$on("triggerGetChatMessages", function (event, args) {
			$scope.getChatMessages();
		});

		
		$scope.$on('$destroy', function() {
			try{$scope.fullScreenImgModal.remove();}catch(e){}			
		});
		
		$('#fileTrnsfrPrsntgDivId').progressCircle({
					nPercent        : 30,
					showPercentText : true,
					circleSize      : 100,
					thickness       : 3
				});
		
}]);			