/**********************************************************************************************************************************************************************************
Author : Sukanya Chatterjee

************************************************************************************************************************************************************************************/


var controllers = angular.module('SelfieApp.controllers',[]);



controllers.controller('MainCtrl', ['$scope', '$state', '$http','$timeout','$cookies', '$ionicModal','$ionicScrollDelegate', 'ApgeeService','$ionicLoading','$ionicPopup','$ionicSlideBoxDelegate',
	function($scope, $state ,$http , $timeout,$cookies, $ionicModal, $ionicScrollDelegate, ApgeeService, $ionicLoading,$ionicPopup, $ionicSlideBoxDelegate) {
	
		/* Start :: Variable/ Declarations   ****************************************************/
		var isIOS = ionic.Platform.isWebView() && ionic.Platform.isIOS();
		$scope.deviceHeight = Math.max(viewport.width,viewport.height);
		$scope.deviceWidth = Math.min(viewport.width,viewport.height);
		
		$scope.pthDeviceType = pthDeviceType;
		
		$scope.leftMenuUserTxt = 'Login';
		$scope.signInModelCancelTxt = '';
		$scope.signUpModelAction = 'New';
		$scope.authMethod = '';
		
		$scope.friends = {};
		$scope.returningUser = (getStoredAppData("authToken") != ''?true:false);
		var imgs = getRandomImage();
		$scope.landingGuyImg = imgs.img1;
		$scope.landingGirlImg = imgs.img2;
		$scope.loadingInProgress = 'true';
		$ionicLoading.show({template: 'Loading...'});
		$scope.pickTheHottiePopup = null;
		$scope.isAboutDetailsShow = false;
		$scope.isAccountDetailsShow = false;
		$scope.isPreferencesShow = false;
		
		//alert('a');
		//try{window.plugins.iAd.showAd(false);}catch(e){}
		//showHideAd(false);
							
		$scope.logedInUser = {username:  '',
							  password:  '',
							  name:      '',
							  profPicSrc:'',
							  email:     '',
							  errorMsg:  ''};
		$scope.logedInUser.username = getStoredAppData("username");
		$scope.logedInUser.profPicSrc  = getStoredAppData("profPicSrc");

		$scope.newUser     = {username:  '',
							  password:  '',
							  name:      '',
							  email:     '',
							  secrtyQstnCd: '',
							  secrtyQstnAns: '',
							  profPicSrc: 'http',
							  errorMsg:  ''};
							  
		$scope.logInUser   = {username:  '',
							  password:  '',
							  name:      '',
							  email:     '',
							  profPicSrc: 'http',
							  errorMsg:  ''};		
		
		$scope.forgetPwdUser  = {username:  '',
							     password:  '',
								 newPassword: '',
							     secrtyQstnCd: '',
							     secrtyQstnAns: ''};
		
		$scope.resetSecrtyUser  = {username:  '',
							     password:  '',
								 newPassword: '',
							     secrtyQstnCd: '',
							     secrtyQstnAns: ''};

		$scope.validatinMsgs = {
			error : false,
			email : ''	,
			logInUser: {email:'' ,
						 password:''}
		};
			
		$scope.firstInitChatCntlTm = 0;
		/* Finish :: Variable/ Declarations  *****************************************************/
		
		
		/* Start :: Page Rendering Utilities  ****************************************************/
		$ionicModal.fromTemplateUrl('sign-in-modal.html', {
			id: 'signInModal',
			scope: $scope,
			backdropClickToClose: false,
			hardwareBackButtonClose: false
		  }).then(function(modal) {
			$scope.signInModal = modal;
		});		

		$ionicModal.fromTemplateUrl('sign-up-modal.html', {
			id: 'signUpModal',
			scope: $scope,
			backdropClickToClose: false,
			hardwareBackButtonClose: false,
			animation: 'slide-in-right'
		  }).then(function(modal) {
			$scope.signUpModal = modal;
		});	

		$scope.showLoginPageTab = 'LOGIN';
		$scope.toggleBetweenLoginTabs = function(tab){
			$scope.resetLogInUser();
			$scope.resetNewUser();
			
			$scope.showLoginPageTab = tab;
			$ionicSlideBoxDelegate.$getByHandle('signUpSlideBox').update();
			$ionicSlideBoxDelegate.$getByHandle("signUpSlideBox").slide(0);
			$ionicSlideBoxDelegate.$getByHandle('signUpSlideBox').enableSlide(0);
			$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').update();
			$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').slide(0);
			$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').enableSlide(0);
			$ionicScrollDelegate.resize();
		}
		
		$ionicModal.fromTemplateUrl('templates/multiChatNew.html', {
			id: 'multiChatModal',
			scope: $scope,
			backdropClickToClose: false,
			hardwareBackButtonClose: false,
			animation: 'slide-in-right'
		  }).then(function(modal) {
			$scope.multiChatModal = modal;
		});	
		
		
		$scope.openMultiChatModal = function(){
			$scope.multiChatModal.show();
			if ( (new Date().getTime() - $scope.firstInitChatCntlTm) > 6000){ // hopefully within 6 sec everything is settle down
				//$ionicLoading.show({template: 'initChatCntl calling ',duration:2000});
				$scope.$root.$broadcast("initChatCntl", {});
			}else{	
				//$ionicLoading.show({template: 'initChatCntl NOT calling ',duration:2000});
			}

		}
		
		$scope.closeMultiChatModal = function(){
			$scope.multiChatModal.hide();
		}
		
		$ionicModal.fromTemplateUrl('templates/multiSuggestion.html', {
			id: 'multiSuggestionModal',
			scope: $scope,
			backdropClickToClose: false,
			hardwareBackButtonClose: false,
			animation: 'slide-in-right'
		  }).then(function(modal) {
			$scope.multiSuggestionModal = modal;
		});	
		
		
		$scope.openMultiSuggestionModal = function(){
			$scope.multiSuggestionModal.show();
			$scope.$root.$broadcast("initMultiSuggestionCtrl", {});

		}
		
		$scope.closeMultiSuggestionModal = function(){
			$scope.multiSuggestionModal.hide();
		}
		
		/* Finish :: Page Rendering Utilities *****************************************************/
		
		
		/* Start :: Page Functions Utilities  *****************************************************/
		
		$scope.resetNewUser  = function(){
			$scope.newUser = {username:  '',
							  password:  '',
							  name:      '',
							  email:     '',
							  secrtyQstnCd: '',
							  secrtyQstnAns: '',
							  profPicSrc: 'http',
							  errorMsg:  ''};
		}
		
		$scope.resetLogInUser  = function(){
			$scope.logInUser = {username:  '',
							    password:  '',
							    name:      '',
							    email:     '',
							    secrtyQstnCd: '',
							    secrtyQstnAns: '',
							    profPicSrc: 'http',
							    errorMsg:  ''};
		}
		
		$scope.resetForgetPwdUser  = function(){
			$scope.forgetPwdUser = {username:  '',
							    password:  '',
							    name:      '',
							    email:     '',
							    secrtyQstnCd: '',
							    secrtyQstnAns: '',
							    profPicSrc: 'http',
							    errorMsg:  ''};
		}
		
		$scope.resetResetSecrtyUser  = function(){
			$scope.resetSecrtyUser  =   {username:  '',
										 password:  '',
										 newPassword: '',
										 secrtyQstnCd: '',
										 secrtyQstnAns: ''};

		}
		
		
		$scope.openLeftMenuItem = function(menuNm){
			if (menuNm == 'SETTINGS'){
				$scope.isAboutDetailsShow = false;
				$scope.isAccountDetailsShow = false;
				$state.go('menu.settings');
			}
			
		}					  
		
								 
								 
		$scope.openUserProfileTabs = function(selectTab){
			gUserProfileSelectTab = selectTab;
			$scope.changeToPortraitView();
			$state.go('menu.userProfileTabs');
			$scope.newUser = appUser.user;
			$scope.profilePicData = $scope.logedInUser.profPicSrc;
			$timeout(function() {
				$scope.$root.$broadcast("onSelectProfileTab", {selectTab: 0});
			},600);
			
		}
		
		$scope.$on("onOpenUserProfileTabs", function (event, args) {
			$scope.openUserProfileTabs(args.selectTab);
		});
		
		$scope.openPickTheHottie = function(src){
			//$scope.changeToLandscapeView();
			//$state.go('menu.home');
			var imgs = getRandomImage();
			$scope.landingGuyImg = imgs.img1;
			$scope.landingGirlImg = imgs.img2;
				
			$scope.pickTheHottiePopup = $ionicPopup.show({
											template:  '<table style="height: 100%;" width="100%" height="100%" border="3">'+
														'<tr height="100%">' +
															'<td align="center"> ' +
																'<div style="text-align:center;width:50%;float:left">'+
																	'<img src="img/{{landingGuyImg}}" ng-click="changeSexPreference(&quot;M&quot;);" width="95%"/>'+
																	'<p style="color:black;"><b>Guys</b></p>'+
																'</div>'+
																'<div style="text-align:center;width:50%;float:left">'+
																	'<img src="img/{{landingGirlImg}}" ng-click="changeSexPreference(&quot;F&quot;)" width="95%"/>'+
																	'<p style="color:black;"><b>Girls</b></p>'+
																'</div>'+
															'</td>'+
														'</tr>'+
														'</table>',
											title: 'Pick The Hottie',
											cssClass: 'sideMenuBG',
											scope: $scope
										  });
			$timeout(function(){$(".popup-buttons").hide();},100);
			if (screen.currOriantation == 'landscape')
				$timeout(function(){$(".popup").css("width", "60%");},100);
			else
				$timeout(function(){$(".popup").css("width", "80%");},100);
		}
		
		$scope.openInviteFriend = function(src){
		
			if ($scope.authMethod != 'fb'){
				$ionicLoading.show({template: 'Please login using FB account', duration: 2000});
				return;
			};
		
			/*var dialog = window.open('https://www.facebook.com/dialog/apprequests?app_id=336714159865545&message=join&access_token=' +
			getStoredAppData("authToken") + '&redirect_uri=https://www.facebook.com/connect/login_success.html', '_blank', 'location=no,closebuttoncaption=Close');*/
			var currOriantation = cordova.plugins.screenorientation.currOrientation;
			$scope.changeToPortraitView();
			openFB.inviteFriendAppRequest(function(response) {
											if (response.status === 'sucessful') {
												if (currOriantation == 'landscape'){
													$scope.changeToLandscapeView();
												}else{	
													$scope.changeToPortraitView();
												}
												//alert('requestId :' + response.reqResponse.requestId);
												var alertPopup = $ionicPopup.alert({
																					 title: 'App Request Confirmation',
																					 template: 'Request has been submitted sucessfully. Request Id is ' + response.reqResponse.requestId
																				   });
												$timeout(function(){$(".popup").css("width", "60%");},100);
												
											}
										  });
		}
		
		
		$scope.openSignInModal = function(src){
			if (src){
				$scope.signInModelCancelTxt = 'X';
			}
			$scope.changeToPortraitView();
			$scope.signInModal.show();			
		};
		
		$scope.closeSignInModal = function(){
			$scope.changeToPortraitView();
			/*$timeout( function() {
			  $ionicScrollDelegate.resize();
			  //alert($ionicScrollDelegate.$getByHandle('mainScroll'));
			  $scope.$broadcast("reSizeMainScroll", {});
			  $ionicScrollDelegate.$getByHandle('mainScroll').resize();
			  
			}, 50);*/
			$scope.logInUser   = {username:  '',
								  password:  '',
								  name:      '',
								  email:     '',
								  profPicSrc: 'http',
								  errorMsg:  ''};	
			$scope.signInModal.hide();
			
		};
		
		$scope.openSignUpModal = function(action){
			$scope.changeToPortraitView();
			$scope.signUpModelAction = action;
			if (action == 'Update'){
				$scope.newUser = appUser.user;
			}
			$scope.signUpModal.show();			
		};
		
		$scope.openForgotPwdModal = function(action){
				
		};
		
		$scope.closeSignUpModal = function(){
			//$scope.changeToLandscapeView();
			$scope.signUpModal.hide();
		};
		
		$scope.changeSexPreference = function(sex){
			//alert('sex:' + sex + ' :: ' + $state.current.name);
			
			if ($scope.pickTheHottiePopup != null){
				$scope.pickTheHottiePopup.close();
			}
			
			$scope.changeToLandscapeView();
			if ($state.current.name != 'menu.home'){
				gSelectedSex.value = sex;
				$state.go('menu.home');
				//$scope.$root.$broadcast("changeSexPref", {value: sex });
			}else{
				//alert('sex:' + sex + ' :: ' + $state.current.name);
				$scope.$root.$broadcast("changeSexPref", {value: sex });
			}
		    
		    //gSelectedSex.value = sex;
		   
		};
		
		
		$scope.getPTHUserDetails = function(pwd,secrtyQstnCd,secrtyQstnAns){
			//alert($scope.logedInUser.username + ':' + $scope.logedInUser.name );
			//authType authId pwd secrtyQstnCd secrtyQstnAns
			
			//alert('0');
			
			var qryStr = imgRootURL + 'addUser?userId='+$scope.logedInUser.username+'&email='+$scope.logedInUser.email+'&full_name='+$scope.logedInUser.name+
						'&authType='+getStoredAppData("authMethod")+'&authId='+getStoredAppData("authToken")+'&pwd='+pwd+'&secrtyQstnCd='+secrtyQstnCd+'&secrtyQstnAns='+secrtyQstnAns+
						'&uuid='+appUser.user.uuid;
			
			getHTTPRequest( qryStr,
						    function(data) {
								//alert('1');
								appUser.user.dob = data.dob;
								appUser.user.location = data.location;
								appUser.user.location_coordinate = data.location_coordinate;
								appUser.user.gender = data.gender;
								appUser.user.picid = data.picid;
								appUser.user.aboutme = data.about_me;
								appUser.user.profPicSrc = (data.picid != null && data.picid != ''?hottieImgBaseUrl+data.picid+'.jpg':'img/user.png');
								appUser.user.name = data.full_name;
								appUser.user.activePicCnt = parseInt(data.activePicCnt)|0;
								appUser.user.secrtyQstnCd = data.secrtyQstnCd;
								appUser.user.secrtyQstnAns = data.secrtyQstnAns;
								appUser.user.pwd = data.password;
								appUser.user.emailVrfd = data.emailValidated; //Y or N
								appUser.user.emailVrfdCd = data.emailValidateCode; //Y or N
								$scope.logedInUser = appUser.user;
								$scope.logedInUser.location = appUser.user.location;
								$scope.logedInUser.profPicSrc = appUser.user.profPicSrc;
								$scope.logedInUser.name = appUser.user.name;
								setStoredAppData("profPicSrc", $scope.logedInUser.profPicSrc);
								//alert('2');
								$scope.resetSecrtyUser.username = $scope.logedInUser.username;
								$scope.resetSecrtyUser.secrtyQstnCd = data.secrtyQstnCd;
								$scope.resetSecrtyUser.secrtyQstnAns = data.secrtyQstnAns;
								$scope.resetSecrtyUser.emailVerf = data.emailValidated;
								//alert('3');
								showHideAd(true);
								$scope.handleExtUrl();
								
								$scope.loadPreferenceData();
								
								
								
								showTour();
								
								try{
									chatManger.initChat();
								}catch(eee){
									//alert('eee ' + eee);
								}
								
								//alert('4');
								$scope.firstInitChatCntlTm =  new Date().getTime();
								$timeout(function(){								
									$scope.$root.$broadcast("initChatCntl", {});								
								},3000);
								
								
								//alert('5');
								//
								//$scope.handleExtUrl();
								//alert('6');
							});
		}
		
		$scope.resetSecrtyPwd = function(){
			$scope.resetValidatinMsgs();
			if ($scope.resetSecrtyUser.password == null || $scope.resetSecrtyUser.password == ''){
				$scope.validatinMsgs.error = true;
				$scope.validatinMsgs.password = 'Password is required';
			}
			
			if ($scope.validatinMsgs.error) return;
			
			var qryStr = imgRootURL + 'addUser?calledFor=SU&userId='+$scope.resetSecrtyUser.username+'&pwd='+$scope.resetSecrtyUser.password +
						'&secrtyQstnCd='+appUser.user.secrtyQstnCd+'&secrtyQstnAns='+appUser.user.secrtyQstnAns;
			showBusy(true);
			getHTTPRequest( qryStr,
							function(data) {
								$ionicLoading.show({template: 'Sucessfully Updated',duration:1000});
								appUser.user.pwd = $scope.resetSecrtyUser.password;		
								setStoredAppData("pwd", appUser.user.pwd);								
							});
			
			/*ApgeeService.updateEntity({ type : 'users',
												uuid : appUser.user.uuid,
												oldpassword:appUser.user.pwd, 
												newpassword:$scope.resetSecrtyUser.password
												},function(err, errMsg){
													if (err){
														$ionicLoading.show({template: 'Error Occured : ' + errMsg.error_description,duration:2000});	
													}else{
														getHTTPRequest( qryStr,
																		function(data) {
																			$ionicLoading.show({template: 'Sucessfully Updated',duration:1000});
																			appUser.user.pwd = $scope.resetSecrtyUser.password;									
																		});
													}
												});*/
												
			
		}
		
		$scope.resetSecrtyQstn = function(){
			$scope.resetValidatinMsgs();
			if ($scope.resetSecrtyUser.secrtyQstnCd == null || $scope.resetSecrtyUser.secrtyQstnCd == ''){
				$scope.validatinMsgs.error = true;
				$scope.validatinMsgs.secrtyQstnCd = 'Security Question is required';
			}
			
			if ($scope.resetSecrtyUser.secrtyQstnAns == null || $scope.resetSecrtyUser.secrtyQstnAns == ''){
				$scope.validatinMsgs.error = true;
				$scope.validatinMsgs.secrtyQstnAns = 'Security Answer is required';
			}
			
			if ($scope.validatinMsgs.error) return;
			
			var qryStr = imgRootURL + 'addUser?calledFor=SU&userId='+$scope.resetSecrtyUser.username+'&pwd='+appUser.user.password +
						'&secrtyQstnCd='+$scope.resetSecrtyUser.secrtyQstnCd+'&secrtyQstnAns='+$scope.resetSecrtyUser.secrtyQstnAns;
			
			showBusy(true);
			getHTTPRequest( qryStr,
						    function(data) {
								$ionicLoading.show({template: 'Sucessfully Updated',duration:1000});
								appUser.user.secrtyQstnCd = $scope.resetSecrtyUser.secrtyQstnCd;	
								appUser.user.secrtyQstnAns = $scope.resetSecrtyUser.secrtyQstnAns;						
							});
			
		}
		
		$scope.verifyEmailVerfCd = function(){
			$scope.resetValidatinMsgs();
			if ($scope.resetSecrtyUser.emailVerfcd == null || $scope.resetSecrtyUser.emailVerfcd == ''){
				$scope.validatinMsgs.error = true;
				$scope.validatinMsgs.emailVerfcd = 'Email Verification Code is required';
			}
			
			if ($scope.validatinMsgs.error) return;
			
			if ($scope.resetSecrtyUser.emailVerfcd == appUser.user.emailVrfdCd){			
				var qryStr = imgRootURL + 'addUser?calledFor=VU&userId='+$scope.resetSecrtyUser.username+'&emailValidated=Y&emailValidateCode='+$scope.resetSecrtyUser.emailVerfcd;
				
				showBusy(true);
				getHTTPRequest( qryStr,
								function(data) {
									$ionicLoading.show({template: 'Email verified sucessfully',duration:1000});
									
									appUser.user.emailVrfd = 'Y';
									$scope.resetSecrtyUser.emailVerf = 'Y';
								
								});
			}else{
				$scope.resetSecrtyUser.emailVerfcd = '';
				$scope.validatinMsgs.error = true;
				$scope.validatinMsgs.emailVerfcd = 'Email Verification Code did not matched. Try Again';
			}
			
		}
		
		$scope.sendEmailVerfCd = function(){
			$scope.resetValidatinMsgs();
			$scope.resetSecrtyUser.emailVerfcd = '';
			
			showBusy(true);
			getHTTPRequest( imgRootURL + 'verifyEmail?userId='+$scope.newUser.username,
											function(data) {
													if (data.verificationCd != ''){
														appUser.user.emailVrfdCd = data.verificationCd;
														var qryStr = imgRootURL + 'addUser?calledFor=VU&userId='+$scope.resetSecrtyUser.username+'&emailValidated=N&emailValidateCode='+data.verificationCd;
														getHTTPRequest( qryStr,
																		function(data) {
																			showBusy(false);
																			
																			
																			appUser.user.emailVrfd = 'N';
																			$scope.resetSecrtyUser.emailVerf = 'N';
																			$scope.resetSecrtyUser.emailVerfcd = '';
																			$scope.validatinMsgs.error = true;
																			$scope.validatinMsgs.emailVerfcd = 'Verification code has been sent to your email id, please enter that';
																		
																		});
													}else{
														alert('error occured');
														showBusy(false);
													}
												}
											);
			
		}
		
		$scope.forgetPassword = function(){
			//alert($scope.logedInUser.username + ':' + $scope.logedInUser.name );
			//authType authId pwd secrtyQstnCd secrtyQstnAns
			$scope.forgetPwdUser.errorMsg = '';
			var qryStr = imgRootURL + 'addUser?calledFor=F&userId='+$scope.forgetPwdUser.username;
			
			getHTTPRequest( qryStr,
						    function(data) {								
									if (data.secrtyQstnCd  == $scope.forgetPwdUser.secrtyQstnCd &&
									    data.secrtyQstnAns == $scope.forgetPwdUser.secrtyQstnAns){ //found match.. we can proceed for new pwd
										$scope.forgetPwdUser.password = data.password;
										$scope.forgetPwdUser.uuid = data.uuid;
										
										$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').enableSlide(1);
										$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').slide(2);
										$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').enableSlide(0);
										$ionicScrollDelegate.resize();					
									}else{
										$scope.forgetPwdUser.errorMsg = 'Security Questions are not mactching. Please try again.';
									}
							});
		}
		
		$scope.resetForgetPwdByEmail = function(){
			var qryStr = imgRootURL + 'resetPwdByEmail?userid='+$scope.forgetPwdUser.username;
			showBusy(true);
			
			getHTTPRequest( qryStr,
							function(data) {
								showBusy(false);
								if (data.status == 'C'){
									var al = $ionicPopup.alert({
													 title: 'Reset Password',
													 template: 'New Password has been sent to your email sucessfully. Please login with the new password.'
												   });
									al.then(function(res) {
										$scope.logOut();
														  });
								}else{
									$scope.forgetPwdUser.errorMsg = 'Error Occured. Please try again.';
								}
							});
		}
		
		$scope.resetForgetPwd = function(){
			$scope.resetValidatinMsgs();
			if ($scope.forgetPwdUser.newPassword == null || $scope.forgetPwdUser.newPassword == ''){
				$scope.validatinMsgs.error = true;
				$scope.validatinMsgs.newPassword = 'Password is required';
			}
			
			if ($scope.validatinMsgs.error) return;
			
			var qryStr = imgRootURL + 'addUser?calledFor=R&userId='+$scope.forgetPwdUser.username+'&pwd='+$scope.forgetPwdUser.newPassword +
						'&secrtyQstnCd='+$scope.forgetPwdUser.secrtyQstnCd+'&secrtyQstnAns='+$scope.forgetPwdUser.secrtyQstnAns;
			showBusy(true);
			
			getHTTPRequest( qryStr,
							function(data) {
								showBusy(false);
								var al = $ionicPopup.alert({
												 title: 'Reset Password',
												 template: 'Password has been reset sucessfully. Please login with new password.'
											   });
								al.then(function(res) {
									$scope.logOut();
													  });						
							});
			
			
		}
		
		
		
		$scope.signIn = function() {
			
			$scope.resetValidatinMsgs();
			
			//$scope.logInUser.username = $scope.logInUser.email;
			if ($scope.logInUser.username == null || $scope.logInUser.username == ''){
				$scope.validatinMsgs.error = true;
				$scope.validatinMsgs.logInUser.username = 'Email is required';
			}
			if ($scope.logInUser.password == null || $scope.logInUser.password == ''){
				$scope.validatinMsgs.error = true;
				$scope.validatinMsgs.logInUser.password = 'Password is required';
			}
			if ($scope.validatinMsgs.error) return;
			
			showBusy(true);
			
			var qryStr = imgRootURL + 'login?userid='+$scope.logInUser.username+'&password='+$scope.logInUser.password;
			
			getHTTPRequest( qryStr,
						    function(data) {
								if (data.login == 'P'){
									appUser = {user:''};
									appUser.user = {};
									$scope.authMethod = 'pt';
									setStoredAppData("authMethod", 'pt');
									setStoredAppData("authToken", '');
									setStoredAppData("username", $scope.logInUser.username);
									setStoredAppData("pwd", $scope.logInUser.password);
									
									$scope.logedInUser.username = $scope.logInUser.username;
									$scope.logedInUser.password = $scope.logInUser.password;
									appUser.user.username = $scope.logInUser.username;
									appUser.user.password = $scope.logInUser.password;
									$scope.getPTHUserDetails('','','');					
								}else{
									//$scope.logInUser.username = '';
									$scope.logInUser.password = '';
									if (data.rsn == 'F'){										
										$scope.logInUser.errorMsg = 'Please use FaceBook Login';
									}else{
										$scope.logInUser.errorMsg = 'Invalid userid or password';
									}
									if ($state.current.name != 'landing'){
										$scope.logOut();
									}
								}
								showBusy(false);
							}
						);				
						
		};
		
		
		
		$scope.resetValidatinMsgs = function(){
			$scope.validatinMsgs = {
				error : false,
				email : '',
				password : '',
				secrtyQstnCd: '',
				secrtyQstnAns: '',
				emailVerfcd:'',
				newPassword: '',
				logInUser: {username:'' ,
						    password:''}
			};
			$scope.logInUser.errorMsg = '';
		}
		
		
		$scope.resendEmailVerifCd = function(){
			var slideBox = $ionicSlideBoxDelegate.$getByHandle("signUpSlideBox");
			getHTTPRequest( imgRootURL + 'verifyEmail?userId='+$scope.newUser.username,
											function(data) {
													if (data.verificationCd != ''){
														slideBox.slide(2);
														$scope.signUpBtnTxt = 'Complete Registration';
														$scope.newUser.verfCd = data.verificationCd;
														$scope.newUser.msg = 'Verification code has been sent to your email id, please enter that to complete the Account creation process';
													}else{
														alert('error occured');
													}
												}
											);
		
		}
		
		
		
		/*
		$scope.$watch('newUser.verificationCd', function (now, then) {
			if (now) {			
				if (now == $scope.newUser.verfCd){
					$scope.signUp();
				}
			}			
		});
		*/
		
		$scope.signUpBtnTxt = 'Next';
		
		$scope.signUp = function() {
			//console.log('Sign-Up', $scope.newUser);
			var slideBox = $ionicSlideBoxDelegate.$getByHandle("signUpSlideBox");
			slideBox.enableSlide(0);
			
			$scope.newUser.msg = '';
			if ($scope.signUpBtnTxt == 'Complete Registration' && $scope.newUser.verfCd != ''){
				if ($scope.newUser.verfCd == $scope.newUser.verificationCd){
					// Account Create
					
					var qryStr = imgRootURL + 'createAccount?userId='+$scope.newUser.username+'&email='+$scope.newUser.email+
									'&authType=pth&pwd='+$scope.newUser.password+'&secrtyQstnCd='+$scope.newUser.secrtyQstnCd+'&secrtyQstnAns='+$scope.newUser.secrtyQstnAns;
						
					getHTTPRequest( qryStr,
							function(data) {
									$scope.isSignUp = true;
									$scope.logInUser.username = $scope.newUser.username;
									$scope.logInUser.password = $scope.newUser.password;
									$scope.signIn();
								}
							);
				}else{
					$scope.newUser.verificationCd = '';
					$scope.newUser.msg = 'Verification code is invalid. Please try again';
				}
				return;
			}
			
			
			// Check if emailid is already registered
			$scope.resetValidatinMsgs();
			$scope.newUser.msg = '';
			$scope.newUser.username = $scope.newUser.email;
			if ($scope.newUser.username == null || $scope.newUser.username == ''){
				$scope.validatinMsgs.error = true;
				$scope.validatinMsgs.email = 'Email is required';
			}
			if ($scope.newUser.password == null || $scope.newUser.password == ''){
				$scope.validatinMsgs.error = true;
				$scope.validatinMsgs.password = 'Password is required';
			}
			/*if ($scope.newUser.name == null || $scope.newUser.name == ''){
				$scope.validatinMsgs.error = true;
				$scope.validatinMsgs.name = 'Name is required';
			}*/
			if ($scope.validatinMsgs.error){
				slideBox.slide(0);
				return;
			}
			
	
			
			
			showBusy(true);
			
			var qryStr = imgRootURL + 'addUser?userId='+$scope.newUser.username+'&calledFor=C';
			
			getHTTPRequest( qryStr,
						    function(data) {
								if ($scope.newUser.username == data.userId){ //userid is already present
									$scope.validatinMsgs.error = true;
									$scope.validatinMsgs.email = 'UserId is already present, please choose a new one';
									slideBox.slide(0);
									showBusy(false);
								}else{
									$scope.signUpBtnTxt = 'Create Account';
									if ($scope.newUser.secrtyQstnCd == null || $scope.newUser.secrtyQstnCd == ''){
										$scope.validatinMsgs.error = true;
										$scope.validatinMsgs.secrtyQstnCd = 'Please Select a Security Question';
									}
									if ($scope.newUser.secrtyQstnAns == null || $scope.newUser.secrtyQstnAns == ''){
										$scope.validatinMsgs.error = true;
										$scope.validatinMsgs.secrtyQstnAns = 'Please Select a Security Answer';
									}
									
									if ($scope.validatinMsgs.error){
										if (slideBox.currentIndex() == 0){
											$scope.validatinMsgs.error = false;											
										}
										slideBox.slide(1);
										showBusy(false);
										return;
									}
									
									getHTTPRequest( imgRootURL + 'verifyEmail?userId='+$scope.newUser.username,
											function(data) {
													showBusy(false);
													if (data.verificationCd != ''){
														
														if (parseInt(data.verificationCd) === -1){
															//alert('Email is not Valid');
															$scope.validatinMsgs.error = true;
															$scope.validatinMsgs.email = 'Email is Not valid. Please double check.';
															slideBox.slide(0);
														
														}else{
															//alert('Email is Valid');
															var qryStr = imgRootURL + 'createAccount?userId='+$scope.newUser.username+'&email='+$scope.newUser.email+
																			'&authType=pth&pwd='+$scope.newUser.password+'&secrtyQstnCd='+$scope.newUser.secrtyQstnCd+'&secrtyQstnAns='+$scope.newUser.secrtyQstnAns
																			+'&emailValidateCode='+ data.verificationCd;
																
															getHTTPRequest( qryStr,
																	function(data) {
																			$scope.isSignUp = true;
																			$scope.logInUser.username = $scope.newUser.username;
																			$scope.logInUser.password = $scope.newUser.password;
																			$scope.signIn();
																		}
																	);
															
														}
														
														
														
														/* stop
														slideBox.slide(2);
														$scope.signUpBtnTxt = 'Complete Registration';
														$scope.newUser.verfCd = data.verificationCd;
														$scope.newUser.msg = 'Verification code has been sent to your email id, please enter that to complete the Account creation process';
														*/
													}else{
														alert('error occured');
													}
												}
											);
								
									
								
									//userid is not present so, good to create the account
									/*var options = {
										type    : 'users',
										username:$scope.newUser.username,
										password:$scope.newUser.password,
										name    :$scope.newUser.name,
										email   :$scope.newUser.email
									};
									ApgeeService.logOut();
									ApgeeService.createEntity(options, function (err, retObj, errDetail) {
										if (err){
										   $scope.newUser.errorMsg = errDetail.error_description;	
										} else {
											$scope.newUser.msg = 'Account is created sucessfully.';
											appUser = retObj;
											$scope.logedInUser = retObj;
											ApgeeService.logOut();
											
											ApgeeService.login($scope.newUser, function (err,retObj){
												if (err){
													$scope.newUser.errorMsg = retObj.error_description;	
												}else{
													$scope.newUser.msg = 'Account Created Sucessfully';	
													$scope.logedInUser = retObj.user;
													$scope.logInUser.username = '';
													$scope.logInUser.password = '';
													//$scope.closeSignInModal();
													$scope.leftMenuUserTxt = 'User';
													$scope.closeSignUpModal();
													$scope.closeSignInModal();
													$scope.authMethod = 'apigee';
													setStoredAppData("authMethod", 'apigee');
													setStoredAppData("authToken", ApgeeService.getToken());
													setStoredAppData("username", $scope.logedInUser.username);
													
													$scope.isSignUp = true;
													$scope.getPTHUserDetails($scope.newUser.password, $scope.newUser.secrtyQstnCd, $scope.newUser.secrtyQstnAns);					
													
												}
												try{$scope.$apply();}catch(ex){}
												
											});
										}
									});	*/								
								}
						
							});
			
		}
		
		$scope.reAskFBPermission = function(){
			
			
			
													  
			openFB.login(
				function(response) {
					if (response.status === 'connected') {						
						openFB.api({
							path: '/me',
							params: {},
							success: function(user) {		

								//email is must.. if user does not grant it then can't continue..
								if (user.email == undefined || user.email == null || user.email == ''){
									var al = $ionicPopup.alert({
												 title: 'FB Details',
												 template: 'Email is required to access PTH. Please check the Email permission for login'
											 });
									al.then(function(res) {
										$scope.reAskFBPermission();
									});
								}else{
									user.username = user.email;
									$scope.logedInUser = user;										
									appUser = user;
									appUser.user = user;
									//$scope.getFBFriends(user.id);
									$scope.logedInUser.profPicSrc = "https://graph.facebook.com/" + $scope.logedInUser.id + "/picture";
									$scope.authMethod = 'fb';
									setStoredAppData("authMethod", 'fb');
									setStoredAppData("authToken", window.sessionStorage['fbtoken']);
									setStoredAppData("username", $scope.logedInUser.username);										
									$scope.getPTHUserDetails('','','');		
								}
							},
							error: function(error) {
								alert('Facebook error: ' + error.message);
							}
						});						
					} else {
						alert('Facebook login failed');
					}
				},
				{scope: 'email',
				 rerequest: true});
		
		}
		
		$scope.fbLogin = function() {
			if (connectionCheck() == false){
				return;
			}
			openFB.login(
				function(response) {
					if (response.status === 'connected') {						
						openFB.api({
							path: '/me',
							params: {},
							success: function(user) {		
								//alert ('user.email ' + user.email);
								//email is must.. if user does not grant it then can't continue..
								if (user.email == undefined || user.email == null || user.email == ''){
									var al = $ionicPopup.alert({
												 title: 'FaceBook Details',
												 template: 'Email is required to access PTH. Please check the Email permission for login.'
											 });
									al.then(function(res) {
										$scope.reAskFBPermission();
									});
									
								}else{
									user.username = user.email;
									$scope.logedInUser = user;										
									appUser = user;
									appUser.user = user;
									//$scope.getFBFriends(user.id);
									$scope.logedInUser.profPicSrc = "https://graph.facebook.com/" + $scope.logedInUser.id + "/picture";
									$scope.authMethod = 'fb';
									setStoredAppData("authMethod", 'fb');
									setStoredAppData("authToken", window.sessionStorage['fbtoken']);
									setStoredAppData("username", $scope.logedInUser.username);										
									$scope.getPTHUserDetails('','','');		
								}
							},
							error: function(error) {
								alert('Facebook error: ' + error.message);
							}
						});						
					} else {
						alert('Facebook login failed');
					}
				},
				{scope: 'email,publish_actions,read_stream,user_friends,user_photos'});
		}
		
		
		$scope.logOut = function (src) {
			
			$scope.logedInUser = {username:  '',
								  password:  '',
								  name:      '',
								  email:     '',
								  profPicSrc: 'http',
								  errorMsg:  ''};
			$scope.resetNewUser();				  
			$scope.resetForgetPwdUser();
			$scope.resetLogInUser();
			$scope.resetResetSecrtyUser();
			
			//ApgeeService.logOut();
			//openFB.revokePermissions(); // no need
			openFB.logout();
			appUser = null;
			$scope.authMethod = '';
			setStoredAppData("authMethod", '');
			setStoredAppData("authToken", '');
			setStoredAppData("username", '');
			setStoredAppData("profPicSrc", '');
			setStoredAppData("sexPrefernce",'');
			$scope.signUpBtnTxt = 'Next';
			$scope.changeToPortraitView();
			$scope.loadingInProgress = 'false';
			if (src == 'landing'){
				$scope.signInModelCancelTxt = 'X';
				$scope.openSignInModal();
			}else{
				showHideAd(false);
				$scope.logedInUser.username = '';
				$state.go('landing');
				$scope.logedInUser.username = '';
				var imgs = getRandomImage();
				$scope.landingGuyImg = imgs.img1;
				$scope.landingGirlImg = imgs.img2;
				
				$timeout(function(){
					$ionicSlideBoxDelegate.$getByHandle('signUpSlideBox').update();
					$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').update();
					$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').slide(0);
					$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').enableSlide(0);
					$ionicScrollDelegate.resize();
				},100);
		
				
			
			}
			
			chatManger.logOutChat();
		}
	
		/* Finish :: Page Functions Utilities  ****************************************************/
		
		
		/* Start :: Other Functions To Support Page Functions  *************************************/
		$scope.changeToLandscapeView = function(){
			try{
				//if (Math.min(viewport.width,viewport.height) < 650){ //only for phone.. for ipad it will not turn..
					//setViewPortWidth(Math.max(viewport.width,viewport.height));
					//screen.lockOrientation('landscape');
					screen.unlockOrientation();
				//}
				
				//alert('Width: ' + viewport.width + ' & Height: ' + viewport.height);
				//var so = cordova.plugins.screenorientation;
				//so.setOrientation('landscape');
				//setViewPortWidth(Math.max(viewport.width,viewport.height));
				//alert('Width: ' + viewport.width + ' & Height: ' + viewport.height);
				//screen.lockOrientation('landscape');
				//setViewPortWidth(viewport.width);
				//$scope.$broadcast("reSizeMainScroll", {});
			}catch(e){
				//alert('msg :' + e);
				//var so = cordova.plugins.screenorientation;
				//so.setOrientation('landscape');
			}
		}
		
		$scope.changeToPortraitView = function(){
			try{
				//var so = cordova.plugins.screenorientation;
				//so.setOrientation('portrait');
				// $scope.$broadcast("reSizeMainScroll", {});
				//alert('Width: ' + viewport.width + ' & Height: ' + viewport.height);
				setViewPortWidth(Math.min(viewport.width,viewport.height));
				//screen.lockOrientation('portrait');
				screen.unlockOrientation();
				
				//setViewPortWidth(viewport.height);
				//$scope.$broadcast("reSizeMainScroll", {});
			}catch(e){
				//alert('msg :' + e);
			}
		};
		
			
		
		
		$scope.getFBFriends = function (id) {
			
			try{
			openFB.api({path: '/me/friends', 
			            params: {},
						success: function (result) {
							$scope.friends = result.data;
							//alert('frnds : ' + $scope.friends);
							//alert('frnds1 : ' + result.data);
						}, 
						error: function(data) {
							alert('error :' + data.error.message);
						}
				});
			}catch(e){
				alert('f:' + e);
			}
			
			/*
			openFB.get('/me/friends', {limit: 10})
				.success(function (result) {
					$scope.friends = result.data;
					//alert('frnds : ' + result);
					//alert('frnds1 : ' + result.data);
				})
				.error(function(data) {
					alert('error :' + data.error.message);
				});*/
		
		};	
		
		
		
		/* Finish :: Other Functions To Support Page Functions *************************************/
		
		/* Start :: Clean Up  **********************************************************************/
		$scope.$on('$destroy', function() {
		  //console.log('Destroying modals...');
		  $scope.signInModal.remove();
		  $scope.multiChatModal.remove();
		  
		});
		
		/* Finish :: Clean Up **********************************************************************/
		
		
		$scope.sharePTHToFB = function(event) {
			try{
				if ('fb' != getStoredAppData("authMethod")){
					$ionicPopup.alert({
										 title: 'Stop',
										 template: 'First Login using FaceBook'
									   });
					return;
				}
				
				$scope.shareMsg = "Check me out on Pick The Hottie. Please install the PTH app from http://itunes.com/apps/pth if you don't have";
				var myPopup = $ionicPopup.show({
												template: '<textarea ng-model="shareMsg" rows="6" id="txtAreaFbShareMsg"></textarea>',
												title: 'Share',
												scope: $scope,
												buttons: [
												  { text: 'Cancel' },
												  {
													text: '<b>Share</b>',
													type: 'button-positive',
													onTap: function(e) {
													  if (!$scope.shareMsg) {
														e.preventDefault();
													  } else {
														openFB.api({
																		method: 'POST',
																		path: '/me/feed',
																		params: {
																			message: $scope.shareMsg					
																		},
																		success: function () {
																			//alert('The session was shared on Facebook');
																			$ionicLoading.show({template: 'The session was shared on Facebook',duration:1000});
																		},
																		error: function (error) {
																			alert('An error occurred while sharing this session on Facebook' + error.message);
																		}
																	});
														
													  }
													}
												  }
												]
											  });
  
				try{autosize($('#txtAreaFbShareMsg'));}catch(e){}
				
			}catch(e){alert(e);}
		};
		
		$scope.setAppRate = function(){
		
			AppRate.preferences.storeAppURL.ios = 'com.pth';
			AppRate.preferences.storeAppURL.android = 'market://details?id=com.pth';
			//AppRate.preferences.storeAppURL.blackberry = 'appworld://content/[App Id]/';
			//AppRate.preferences.storeAppURL.windows8 = 'ms-windows-store:Review?name=<the Package Family Name of the application>';
			AppRate.promptForRating(true);
		}
		
		$scope.$watch('preferences.sex', function (now, then) {
			if (now) {			
				setStoredAppData('preferences.sex',now);
			}			
		});
		
		$scope.$watch('preferences.srchRadius', function (now, then) {
			if (angular.isNumber(now)) {
				if (parseInt(now) > 999){
					$scope.preferences.srchRadius = parseInt(then)||200;
					return;
				}
				setStoredAppData('preferences.srchRadius',parseInt(now));
			}	
			if (now == undefined && angular.isNumber(then) && parseInt(then)>99){
				$scope.preferences.srchRadius = parseInt(then)||200;
			}
		});
		
		$scope.currLocationCordinate = '';
		$scope.preferences = {};
		$scope.loadPreferenceData = function(){
			$scope.preferences.srchRadius = parseInt(getStoredAppData('preferences.srchRadius'))||200;
			
			if (getStoredAppData('preferences.sex') == 'M' || getStoredAppData('preferences.sex') == 'F'){
				$scope.preferences.sex = getStoredAppData('preferences.sex');
			} else if (appUser.user.gender == 'M'){
				$scope.preferences.sex = 'F';
			}else if (appUser.user.gender == 'F'){
				$scope.preferences.sex = 'M';
			}else{
				$scope.preferences.sex = 'F';
			}
			
			
			if(navigator.geolocation) {
				navigator.geolocation.getCurrentPosition(function(position) {
					//alert(position.coords.latitude + ' - ' + position.coords.longitude);
					$scope.currLocationCordinate = '('+ position.coords.latitude + ',' + position.coords.longitude + ')';
					
					var latlng = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
					var geocoder = new google.maps.Geocoder();
					geocoder.geocode({'location': latlng}, function(results, status) {
						if (status == google.maps.GeocoderStatus.OK) {
							if (results[1]) {
								$scope.currLocation = results[1];							
						  } else {
							alert('No results found');
						  }
						} else {
						  alert('Geocoder failed due to: ' + status);
						}
					});
  
					
					
					//$scope.getHotties('NEARMENOW',getStoredAppData('preferences.srchRadius')||200);
				}, function() {
				  //alert('fails');
				});
			} else {
				// Browser doesn't support Geolocation
				//alert('does not support');
			}
		
		}
		
		
		$scope.returnUserExecute = function(){
			try{
				
				
				$scope.authMethod = getStoredAppData("authMethod");
				if ('fb' == getStoredAppData("authMethod") && getStoredAppData("authToken") != '' && connectionCheck() == true &&
					getStoredAppData("username") != undefined && getStoredAppData("username") != 'undefined' && getStoredAppData("username") != null &&
					getStoredAppData("username") != ''){
					window.sessionStorage['fbtoken'] = getStoredAppData("authToken");
					openFB.api({
								path: '/me',
								params: {},
								success: function (user) {									
									user.username = user.email;
									$scope.logedInUser = user;
									$scope.getFBFriends(user.id);
									$scope.logedInUser.profPicSrc = "https://graph.facebook.com/" + $scope.logedInUser.id + "/picture";
									appUser = user;
									appUser.user = user;
									$scope.authMethod = 'fb';
									setStoredAppData("authMethod", 'fb');
									setStoredAppData("authToken", window.sessionStorage['fbtoken']);
									setStoredAppData("username", $scope.logedInUser.username);									
									$scope.getPTHUserDetails('','','');									
									$scope.loadingInProgress = 'false';
									$ionicLoading.show({template: 'Done', duration:1});																		
								},
								error:function (err) {
									
									$ionicLoading.hide();		
									/*
									gIonicPopup.alert({
										title: "Error in FB Login",
										content: err.message
									})
									.then(function(result) {
										
									});
									*/
									$scope.loadingInProgress = 'false';
									$scope.logedInUser.username = '';
									$scope.authMethod = '';
									setStoredAppData("authMethod", '');
									setStoredAppData("authToken", '');
									setStoredAppData("username", '');
									setStoredAppData("profPicSrc", '');
									$scope.logOut();	
									$scope.fbLogin();
								}
								});	
					//$scope.closeSignInModal();
				}else if ('pt' == getStoredAppData("authMethod") && connectionCheck() == true && getStoredAppData("username") != undefined && getStoredAppData("username") != 'undefined' && getStoredAppData("username") != null &&
					getStoredAppData("username") != '') {
					$scope.logInUser.username = getStoredAppData("username");
					$scope.logInUser.password = getStoredAppData("pwd");
					$scope.signIn();
							
				}else if (connectionCheck() == true){
					//$scope.openSignInModal();
					//$scope.changeToPortraitView();
					$scope.authMethod = '';
					$scope.logedInUser.username = '';
					setStoredAppData("authMethod", '');
					setStoredAppData("authToken", '');
					setStoredAppData("username", '');
					setStoredAppData("profPicSrc", '');
					$scope.loadingInProgress = 'false';
					$scope.logOut();
					$ionicLoading.hide();
				}else{
					$ionicLoading.hide();
				};
	
			}catch(e){
				alert(e);
			}	
		
		}
		
		$scope.$on("onReturnUserExecute", function (event, args) {
			$scope.returnUserExecute();
		});
		
		//alert('b');
		
		// Initial Load
		if (appUser == undefined || appUser == null){
			$timeout( function() {
				$scope.returnUserExecute();				
			},5);
		}else{
			$scope.logedInUser = appUser.user;
		}
		
		$scope.isSignUp  = false;
		$scope.handleExtUrl = function(){
			//alert('$scope.isSignUp ' + $scope.isSignUp);
			var extLoadUrl = getStoredAppData("external_load");
			if ($scope.isSignUp == true){
				$state.go('menu.aboutme');
				$scope.isSignUp  = false;
			}else{
				var sex = gSelectedSex.value;
				gSelectedSex.value = '';
				$scope.changeSexPreference(sex);
			}
			
			
			
			//alert('handleExtUrl');
			//if (extLoadUrl != undefined && extLoadUrl != ''){
				//$state.go('menu.home');
			//}
			
		}
		
		$scope.showForgetPwdForm = function(a){	

			$scope.resetValidatinMsgs();
			$scope.resetForgetPwdUser();
			
			if ($scope.logInUser.username == null || $scope.logInUser.username == ''){
				$scope.validatinMsgs.error = true;
				$scope.validatinMsgs.logInUser.username = 'Email is required';
				return;
			}
			
			 var qryStr = imgRootURL + 'addUser?calledFor=F&userId='+$scope.logInUser.username;
			
			getHTTPRequest( qryStr,
						    function(data) {								
									if (data.userId  == $scope.logInUser.username){ //found match.. we can proceed for new pwd
									
										if (data.secrtyQstnCd == null || data.secrtyQstnCd == ''){
											$ionicLoading.show({template: 'Sorry Forget Password can not be used as security is not set up', duration:1500});
										}else{
											$scope.forgetPwdUser.password = data.password;
											
											$scope.forgetPwdUser.username = $scope.logInUser.username;	
											$scope.forgetPwdUser.secrtyQstnCd = data.secrtyQstnCd;
				
											$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').enableSlide(1);
											$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').slide(1);
											$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').enableSlide(0);
											$ionicScrollDelegate.resize();
										}
			
									}else{
										$ionicLoading.show({template: 'Username is not present', duration:1500});
									}
							});

		
			
		}
		
		$scope.onSwipeRightLoginSlideBox = function(){
			$scope.resetLogInUser();
			$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').enableSlide(1);
			$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').slide(0);
			$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').enableSlide(0);
			$ionicScrollDelegate.resize();
			
		}
		
		$scope.$on('$stateChangeStart',function(event, toState, toParams, fromState, fromParams){ 
			//$ionicLoading.show({template: 'stateChangeStarted .. fromState : ' + fromState.name + ' toState :' + toState.name, duration:1500});
		});
		
		$scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams) {
			//$ionicLoading.show({template: 'stateChangeSuccess .. fromState : ' + fromState.name + ' toState :' + toState.name, duration:1500});
			//alert('toState.name'+toState.name);
			if (toState.name=='landing'){
				showHideAd(false);
				
				$timeout(function(){
					$ionicSlideBoxDelegate.$getByHandle('signUpSlideBox').update();
					$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').update();
					$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').slide(0);
					$ionicSlideBoxDelegate.$getByHandle('loginSlideBox').enableSlide(0);
					$ionicScrollDelegate.resize();
				},100);
				
			}else{
				showHideAd(true);
			}
			
		});
		
		
		
		$scope.showHideAboutDetails = function(){
			$scope.isAboutDetailsShow = !$scope.isAboutDetailsShow ;
		}
		
		$scope.showHideAccountDetails = function(){
			$scope.isAccountDetailsShow = !$scope.isAccountDetailsShow ;
		}
		
		$scope.showHidePreferences= function(){
			$scope.isPreferencesShow = !$scope.isPreferencesShow ;
		}
		
		$scope.openUrl = function(url){
			//alert(url);
			window.open(url, '_blank', 'location=no,closebuttoncaption=Close');
		}
		
		$scope.$on("bradCastEvent", function (event, args) {
			$timeout(function() {
				if (args.evt = 'showHideAccountDetails'){
					$scope.isAccountDetailsShow = false;
					$scope.showHideAccountDetails();
				}
			},100);
		});
		
	
		
		
		
		
		
		$scope.inputUp = function() {
			//if (isIOS) $scope.data.keyboardHeight = 216;
			$timeout(function() {
			  $ionicScrollDelegate.scrollBottom(true);
			}, 300);

		};

		$scope.inputDown = function() {
			//if (isIOS) $scope.data.keyboardHeight = 0;
			$ionicScrollDelegate.resize();
		};

		$scope.closeKeyboard = function() {
			//cordova.plugins.Keyboard.close();
		};
		
		
		
		
		
		
		
		
		
		
		
	
		$scope.leftButtons = [
			{ 
			type: 'button-clear',
			content: '<i class="icon ion-navicon"></i>',
			tap: function(e) {
					$scope.sideMenuController.toggleLeft();
				}
			}
		];
	
		

  
	// Main app controller, empty for the example

}]);


 
controllers.controller('CameraCtrl', ['$scope','$state', '$ionicLoading','$timeout','$ionicPopup',
	
	function ($scope,$state, $ionicLoading, $timeout, $ionicPopup) {
		$scope.data = { "ImageURI" :  "Select Image" };
		
		$scope.profilePicData = 'http';
		$scope.personalUploadedPicData = 'http';
		
		$scope.$on("onTakePicture", function (event, args) {
			$scope.takePicture(args.calledFrom);
		});
		
		$scope.$on("onSelectPicture", function (event, args) {
			$scope.selectPicture(args.calledFrom);
		});
		
		$scope.takePicture = function(calledFrom) {
		
			if (appUser.user.gender== undefined || appUser.user.gender==null || appUser.user.gender==''){
				var alertPopup = $ionicPopup.alert({
													 title: 'Image Upload',
													 template: 'First Update your profile in About Me'
												   });
				$timeout(function(){$(".popup").css("width", "60%");},100);
				alertPopup.then(function(res) {
					$state.go('menu.aboutme');
				});
				return;
			}
			
			try{
				 navigator.camera.getPicture(function(imageURI) {
					if (calledFrom == 'UPDATE_PROFILE_PIC'){
						$scope.profilePicData = imageURI;						
					}else{
						$scope.personalUploadedPicData = imageURI;
					}
					try{$scope.$apply();}catch(ex){}
					$scope.uploadPicture(calledFrom);
					
				}, function(err) {
					//alert(err);
				}, {
					quality: 75,
					targetWidth: 760,
					targetHeight: 760,
					saveToPhotoAlbum: false				
				});

				/*
				Camera.getPicture().then(function(imageURI) {
				console.log(imageURI);
				$scope.picData = imageURI;
				}, function(err) {
				console.err(err);
				}, {
				quality: 75,
				targetWidth: 320,
				targetHeight: 320,
				saveToPhotoAlbum: false
				});

				
				var options = {
					quality: 50,
					destinationType: 1, //Camera.DestinationType.FILE_URL
					sourceType: 1 //Camera.PictureSourceType.CAMERA
				};
				$cordovaCamera.getPicture(options).then(
					function(imageData) {
						$scope.picData = imageData;
						$scope.ftLoad = true;
						//$localstorage.set('fotoUp', imageData);
						$ionicLoading.show({template: 'Foto acquisita...', duration:500});
					},
					function(err){
						$ionicLoading.show({template: 'Errore di caricamento...', duration:500});
					}
				);
				*/
			}catch(e){
				alert(e);
			}
		  }

		$scope.selectPicture = function(calledFrom) { 
			if (appUser.user.gender== undefined || appUser.user.gender==null || appUser.user.gender==''){
				var alertPopup = $ionicPopup.alert({
													 title: 'Image Upload',
													 template: 'First Update your profile in About Me'
												   });
				$timeout(function(){$(".popup").css("width", "60%");},100);
				alertPopup.then(function(res) {
					$state.go('menu.aboutme');
				});
				return;
			}
		
			try{
				var options = {
					quality: 50,
					destinationType: 1, /*Camera.DestinationType.FILE_URI,*/
					sourceType: 0 /*Camera.PictureSourceType.PHOTOLIBRARY*/
				};
				
				navigator.camera.getPicture(
					function(imageURI) {
						
						window.resolveLocalFileSystemURI(imageURI, function(fileEntry) {
							
							if (calledFrom == 'UPDATE_PROFILE_PIC'){
								$scope.profilePicData = fileEntry.nativeURL;						
							}else{
								$scope.personalUploadedPicData = fileEntry.nativeURL;
							}							
							try{$scope.$apply();}catch(ex){}
							$scope.uploadPicture(calledFrom);
						});
						/*
						console.log(imageURI);
						//alert(imageURI);
						$scope.picData = imageURI;
						$scope.$apply();
						$scope.uploadPicture();
						*/
					
					}, function(err) {
						//alert(err);
					}, {
						quality: 75,
						targetWidth: 760,
						targetHeight: 760,
						destinationType: 1, 
						sourceType: 0 		
					}
				);
				
				
			/*
				$cordovaCamera.getPicture(options).then(
					function(imageURI) {
						window.resolveLocalFileSystemURI(imageURI, function(fileEntry) {
							$scope.picData = fileEntry.nativeURL;
							$scope.ftLoad = true;
							var image = document.getElementById('myImage');
							image.src = fileEntry.nativeURL;
						});
						$ionicLoading.show({template: 'Foto acquisita...', duration:500});
					},
					function(err){
						$ionicLoading.show({template: 'Errore di caricamento...', duration:500});
					}
				);*/
			}catch(e){
				alert(e);
			}
		};

		$scope.uploadPicture = function(calledFrom) {
			$ionicLoading.show({template: 'Uploading....' });
			var fileURL = '';
			if (calledFrom == 'UPDATE_PROFILE_PIC'){
				fileURL = $scope.profilePicData;						
			}else{
				fileURL = $scope.personalUploadedPicData;
			}	
			var options = new FileUploadOptions();
			options.fileKey = "file";
			options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
			options.mimeType = "image/jpeg";
			options.chunkedMode = true;

			/*var params = {};
			params.value1 = "someparams";
			params.value2 = "otherparams";*/
			var params = {userName       : appUser.user.username,
						  calledFor      : calledFrom,
						  faceDetect     : 'true',
						  gender         : appUser.user.gender};
						  

			options.params = params;

			var ft = new FileTransfer();
			ft.upload(fileURL, 
					    encodeURI(imgRootURL +'uploadPics'), 
					    function(sucess) {
							//alert("Code = " + sucess.responseCode);
							//alert("Response = " + sucess.response);
							//alert("Sent = " + sucess.bytesSent);
							//$scope.savedPics.push( {imgUrl: imgRootURL + 'get-file?filePath=' + sucess.response});
							
							$ionicLoading.hide();
							
							var retCd = getValueByRegExp(sucess.response,'returnCd')[0];
							if (retCd == 'R'){ // rejected
								var alertPopup = $ionicPopup.alert({
																	 title: 'Image Upload Rejected',
																	 template: getValueByRegExp(sucess.response,'returnMsg')[0]
																   });
								$timeout(function(){$(".popup").css("width", "60%");},100);
								
							}else{							
															
								var imageId = getValueByRegExp(sucess.response,'file')[0];
								var picId = imageId.split('.')[0];
								$ionicLoading.show({template: 'Image ' +  picId + ' is uploaded and submitted for approval...', duration: 3000});
								var dim = getValueByRegExp(sucess.response,'dimension')[0];
								$scope.pendingHotties.push( {
									picId: picId,
									url: hottieImgBaseUrl + imageId,
									status: 'I',
									sex: 'F',
									dimension: dim
									});
								$timeout(function() {
									$("#pendingImageGalaryDiv").justifiedGallery({rowHeight:(isPad==true?160:70),lastRow:'nojustify',margins:3});
								},100);
							}
							
							
							//$ionicLoading.hide();
						}, 
						function(error) {
							$ionicLoading.show({template: 'Error in Upload...', duration: 1000});
							//$ionicLoading.hide();
						}, 
						options);
		}

		var viewUploadedPictures = function() {
			$ionicLoading.show({template: 'Sto cercando le tue foto...'});
			server = "http://www.yourdomain.com/upload.php";
			if (server) {
				var xmlhttp = new XMLHttpRequest();
				xmlhttp.onreadystatechange=function(){
				if(xmlhttp.readyState === 4){
						if (xmlhttp.status === 200) {					 
					document.getElementById('server_images').innerHTML = xmlhttp.responseText;
						}
						else { $ionicLoading.show({template: 'Errore durante il caricamento...', duration: 1000});
						return false;
						}
					}
				};
				xmlhttp.open("GET", server , true);
				xmlhttp.send()}	;
			$ionicLoading.hide();
		}

		$scope.viewPictures = function() {
			$ionicLoading.show({template: 'Sto cercando le tue foto...'});
			server = "http://www.yourdomain.com/upload.php";
			if (server) {
				var xmlhttp = new XMLHttpRequest();
				xmlhttp.onreadystatechange=function(){
				if(xmlhttp.readyState === 4){
						if (xmlhttp.status === 200) {					 
					document.getElementById('server_images').innerHTML = xmlhttp.responseText;
						}
						else { $ionicLoading.show({template: 'Errore durante il caricamento...', duration: 1000});
						return false;
						}
					}
				};
				xmlhttp.open("GET", server , true);
				xmlhttp.send()}	;
			$ionicLoading.hide();
		}
}]);
 
 
 
 

 
 
 

 
 
 


controllers.controller('uploadCtrl', ['$scope', '$http', '$timeout', '$upload',

	function($scope, $http, $timeout, $upload) {
	
		$scope.saveRatingToServer = function(rating) {
		  //alert('Rating selected - ' + rating);
		};
		
		$scope.profileImgSrc = 'http';
		$scope.pageName = '';
		$scope.fileReaderSupported = window.FileReader != null;
		$scope.uploadRightAway = true;
		$scope.howToSend = 1;
		$scope.httpMethod = 'POST';
		$scope.changeAngularVersion = function() {
			window.location.hash = $scope.angularVersion;
			window.location.reload(true);
		}
		$scope.hasUploader = function(index) {
			return $scope.upload[index] != null;
		};
		$scope.abort = function(index) {
			$scope.upload[index].abort(); 
			$scope.upload[index] = null;
		};
		$scope.angularVersion = window.location.hash.length > 1 ? window.location.hash.substring(1) : '1.2.0';
		$scope.onFileSelect = function($files, pageNm) {
			$scope.msg = '';
			$scope.errorMsg = '';
			$scope.pageName = pageNm;
			$scope.selectedFiles = [];
			$scope.progress = [];
			if ($scope.upload && $scope.upload.length > 0) {
				for (var i = 0; i < $scope.upload.length; i++) {
					if ($scope.upload[i] != null) {
						$scope.upload[i].abort();
					}
				}
			}
			$scope.upload = [];
			$scope.uploadResult = [];
			$scope.selectedFiles = $files;
			$scope.dataUrls = [];
			
			for ( var i = 0; i < $files.length; i++) {
				var $file = $files[i];
				if (window.FileReader && $file.type.indexOf('image') > -1) {
					var fileName = $file.name;
					var fileReader = new FileReader();
					fileReader.readAsDataURL($files[i]);
					function setPreview(fileReader, index) {
						fileReader.onload = function(e) {
							$timeout(function() {
								$scope.dataUrls[index] = e.target.result;
								if ($scope.pageName == 'UpdateUserAcct'){
									$scope.profileImgSrc = e.target.result;
									$scope.user.picture = fileName;
								}
								/*
								var options = new FileUploadOptions();
								options.fileKey="ffile";
								options.fileName="hh.jpg";
								options.mimeType="image/jpeg";
								var params = {};
								params.other = 'aa'; // some other POST fields
								options.params = params;
								
								//console.log("new imp: prepare upload now");
								var ft = new FileTransfer();
								ft.upload(e.target.result, encodeURI("http://54.9.10.239:8080/SelfieServerSide/rest/file/upload"), uploadSuccess, uploadError, options);
								function uploadSuccess(r) {
									// handle success like a message to the user
									};
								function uploadError(error) {
									//console.log("upload error source " + error.source);
									//console.log("upload error target " + error.target);
									};
								
								*/
								
								
							});
						}
					};
					setPreview(fileReader, i);
				}
				$scope.progress[i] = -1;
				if ($scope.uploadRightAway) {
					$scope.start(i);
				}
			}
		};
	
		$scope.start = function(index) {
			$scope.progress[index] = 0;
			var dataModel = {};
			if ($scope.pageName == 'UpdateUserAcct'){
				dataModel = {userName       : appUser.user.username,
							 calledFor      : 'UPDATE_PROFILE_PIC'};
			}else{
				dataModel = {userName : appUser.user.username,
							 calledFor      : 'UPLOAD_PICS'};
			}
			if ($scope.howToSend == 1) {
				$scope.upload[index] = $upload.upload({
					url: imgRootURL +'upload',
					method: $scope.httpMethod,
					headers: {'myHeaderKey': 'myHeaderVal'},
					data : dataModel,
					/* formDataAppender: function(fd, key, val) {
						if (angular.isArray(val)) {
							angular.forEach(val, function(v) {
							  fd.append(key, v);
							});
						  } else {
							fd.append(key, val);
						  }
					}, */
					file: $scope.selectedFiles[index],
					fileFormDataName: 'myFile'
				}).then(function(response) {
					$scope.uploadResult.push(response.data);
					if ($scope.pageName == 'UpdateUserAcct'){
						var profPic = appUser.user.username + '_proppic.' + $scope.selectedFiles[index].name.split('.')[1];
						//$scope.user.picture = $scope.selectedFiles[index].name;
						//$scope.user.picture = appUser.user.username + '_proppic' + $scope.selectedFiles[index].name.split('.')[1];
						appUser.appgeeUser.set({"picture":profPic});
						appUser.appgeeUser.save(function (err) {
							if (err) {
							 
							} else {
								$scope.msg = 'Account is updated sucessfully';
								//alert('Your account was updated');
									/*
									$ionicPopup.prompt({
									  title: 'Confirmation',
									  content: 'Account is updated'
									}).then(function(res) {
									  console.log('Your name is', res);
									});*/
								
							}
							$scope.$parent.$apply();
						});
					}
					
				}, null, function(evt) {
					$scope.progress[index] = parseInt(100.0 * evt.loaded / evt.total);
				});
			} else {
				var fileReader = new FileReader();
				fileReader.onload = function(e) {
					$scope.upload[index] = $upload.http({
						url: 'http://54.9.10.239:8080/SelfieServerSide/rest/file/upload',
						headers: {'Content-Type': $scope.selectedFiles[index].type},
						data: e.target.result
					}).then(function(response) {
						$scope.uploadResult.push(response.data);
					}, null, function(evt) {
						// Math.min is to fix IE which reports 200% sometimes
						$scope.progress[index] = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
					});
				}
				fileReader.readAsArrayBuffer($scope.selectedFiles[index]);

			}
		};
		
		
} ])

.filter('split', function() {
        return function(input, splitChar, splitIndex) {
            // do some bounds checking here to ensure it has that index
			if (input == null || input == undefined) return '';
			
            return input.split(splitChar)[splitIndex];
        }
    })
	
.filter('locationCityOnly', function() {
        return function(input) {
			return locationCityOnly(input);			
        }
    })
	
.filter('calculateAge', function() {
        return function(dobStr) {
			return getAge(dobStr);
        }
    })
	
.filter('getChatDtTm', function() {
        return function(datetime) {
			if (datetime != null && datetime != '' && angular.isDate(datetime)){
				var toDay = new Date();
				try{
					if (toDay.getFullYear() == datetime.getFullYear() && toDay.getDay() == datetime.getDay() && toDay.getDate() == datetime.getDate()){ // today so only show time
						return gAngularFilter('date')(datetime,'h:mm a');
					}else if (toDay.getFullYear() == datetime.getFullYear()){
						return gAngularFilter('date')(datetime,'MMM d, h:mm a');
					}
				}catch(e){
					alert(e);
				}
				return  gAngularFilter('date')(datetime,'MMM d, y h:mm a');
			
			}
			return '';
        }
    })

.filter('unsafe', function($sce) {
    return function(val) {
		/*alert(val.
				replace(/</g, '&lt;').
				replace(/>/g, '&gt;').
				replace(/(http[^\s]+)/g, '<a href="#" onclick="openUrl(\'$1\')" ng-click="openUrl(\'$1\')">$1</a>'));*/
        return  $sce.trustAsHtml(val.
                                replace(/</g, '&lt;').
                                replace(/>/g, '&gt;').
                                replace(/(http[^\s]+)/g, '<a href="#" onclick="openUrlInSystemBrowser(\'$1\')">$1</a>')
								                         
                               );
		//replace(/(http[^\s]+)/g, '<a href="$1">$1</a>')
	
	}
})

	
.filter('parseInt', function() {
        return function(input) {
			try{	
				return parseInt(input);
			}catch(e){
				return 0;
			}
        }
    })
;





controllers.controller('HomeIndexCtrl', function($scope) {
  // "Pets" is a service returning mock data (services.js)
  
});

// A simple controller that fetches a list of data from a service
controllers.controller('PetIndexCtrl', function($scope, PetService) {
  // "Pets" is a service returning mock data (services.js)
  $scope.pets = PetService.all();
});


// A simple controller that shows a tapped item's data
controllers.controller('PetDetailCtrl', function($scope, $stateParams, PetService) {
  // "Pets" is a service returning mock data (services.js)
  $scope.pet = PetService.get($stateParams.petId);
});

function hexToBase64(str) {
    return btoa(String.fromCharCode.apply(null, str.replace(/\r|\n/g, "").replace(/([\da-fA-F]{2}) ?/g, "0x$1 ").replace(/ +$/, "").split(" ")));
}

function nextSlidePic1(imgList,currIndx) {
	if (imgList.length > currIndx - 2){
		return {imgSrc : imgList[currIndx + 1].imgSrc,
				currIndx : currIndx + 1};
	}else{
		return {imgSrc : imgList[0].imgSrc,
				currIndx : 0};
	}
}

function nextSlidePic(imgList) {
	try{
		if (imgList.length -1 > picCurrIndexOnSlide){
			picCurrIndexOnSlide = picCurrIndexOnSlide + 1;
			return imgList[picCurrIndexOnSlide].imgSrc;
		}else{
			picCurrIndexOnSlide = 0;
			return imgList[0].imgSrc;
		}
	}catch(e){
		alert(e);
	}
}

function currSlidePic(imgList) {
	return imgList[picCurrIndexOnSlide].imgSrc;
}

function locationCityOnly(input){
	if (input == null || input == undefined) return '';
			
	// do some bounds checking here to ensure it has that index
	var parts = input.split(',');
	if (parts.length == 2){// that means only city and country to return only City
		return parts[0];
	}else if (parts.length == 3){// that means only city, state and country to return only City
		return parts[0] + "," + parts[1].replace(/(\d+)/g,'');
	}
	return input;
}




