/*global angular*/

(function() {
    'use strict';

    angular.module('rn-lazy', []).
    directive('rnLazyBackground', ['$document', '$parse', function($document, $parse) {
        return {
            restrict: 'AC',
            link: function(scope, iElement, iAttrs) {
                function setLoading(elm) {
                    if (loader) {
                        elm.html('');
                        elm.append(loader);
                        elm.css({
                            'background-image': null
                        });
                    }
                }
                var loader = null;
                if (angular.isDefined(iAttrs.rnLazyLoader)) {
                    loader = angular.element($document[0].querySelector(iAttrs.rnLazyLoader)).clone();
                }
                var bgModel = $parse(iAttrs.rnLazyBackground);
                scope.$watch(bgModel, function(newValue) {
                    setLoading(iElement);
					//iElement.html('aaa');
					//iElement[0].innerHTML = 'ggggggg';
                    var src = bgModel(scope);
                    var img = $document[0].createElement('img');
                    img.onload = function() {
                        if (loader) {
                            loader.remove();
                        }
                        if (angular.isDefined(iAttrs.rnLazyLoadingClass)) {
                            iElement.removeClass(iAttrs.rnLazyLoadingClass);
                        }
                        if (angular.isDefined(iAttrs.rnLazyLoadedClass)) {
                            iElement.addClass(iAttrs.rnLazyLoadedClass);
                        }
						/*
						var canvas = document.createElement("canvas");
						canvas.width =this.width;
						canvas.height =this.height;

						var ctx = canvas.getContext("2d");
						ctx.drawImage(this, 0, 0);


						var dataURL = canvas.toDataURL("image/png");

						var imgData =  dataURL.replace(/^data:image\/(png|jpg);base64,/, "");*/
	
                        iElement.css({
                             'background-image': 'url(' + this.src + ')'
                        });
						iElement.css('width', '99%');
						iElement.css('height', (iElement[0].clientHeight + 300) + 'px');
						
                    };
                    img.onerror= function() {
                        console.log('error');
                    };
                    img.src = src;
                });
            }
        };
    }]);
})();
