/**********************************************************************************************************************************************************************************
Author : Sukanya Chatterjee

************************************************************************************************************************************************************************************/

controllers.controller('multiSuggestionCtrl', ['$scope', '$state', '$http', '$ionicSlideBoxDelegate','$ionicScrollDelegate','$timeout','$ionicLoading','$ionicModal','$ionicPopup',
	
	function($scope, $state, $http, $ionicSlideBoxDelegate, $ionicScrollDelegate, $timeout, $ionicLoading, $ionicModal,$ionicPopup) {
		

		$scope.suggestions = [];
		$scope.allSuggestions = [];
		$scope.suggestionsPerReq = [];
		
		$scope.initMultiSuggestionCtrl = function(){
			if (appUser == undefined || appUser == null) return;
			
			$scope.suggestions = [];
			$scope.allSuggestions = [];
			$scope.suggestionsPerReq = [];
			
			$scope.getSuggestions();
		
		}
		
		
		$scope.getSuggestions = function(){		
			getHTTPRequest( imgRootURL + 'executeService?service=suggestionReq&calledFor=S&createdBy='+ appUser.user.username,
						    function(data) {
								if (data == 'null') return;
								
								var reqId = 0;
								angular.forEach(data, function(value, key){
									value.createdDt = new Date(value.createdDt.replace(' ','T'));
									$scope.allSuggestions.push(value);
									if (reqId != value.reqId){
										$scope.suggestions.push(value);
										reqId = value.reqId;
									}									
								});							
							}
						);
		}
		
		$ionicModal.fromTemplateUrl('templates/indvSuggestion.html', {
			id: 'indvSuggestionModal',
			scope: $scope,
			backdropClickToClose: false,
			hardwareBackButtonClose: false,
			animation: 'slide-in-right'
		  }).then(function(modal) {
			$scope.indvSuggestionModal = modal;
		});	
		
		
		$scope.openIndvSuggestionModal = function(sugg){	
			try{
				$scope.newSugg = {
					reqId: 0,
					reqType: '',
					comments: '', 
					createdBy: ''
				};
				$scope.suggestionsPerReq = [];
				if (sugg != undefined){
					$scope.newSugg.reqId = sugg.reqId;
					$scope.newSugg.reqType = sugg.reqType;
					$scope.newSugg.createdBy = sugg.createdBy;
					$scope.suggestionsPerReq = [];
					angular.forEach($scope.allSuggestions, function(value, key){
						if ($scope.newSugg.reqId == value.reqId){
							if (value.createdBy == 'admin'){
								value.author = 'admin';
							}else{
								value.author = 'me';
								value.authrPropPic = appUser.user.profPicSrc;								
							}
							$scope.suggestionsPerReq.push(value);
						}									
					});			
				}					
				$scope.indvSuggestionModal.show();
			}catch(e){
				alert(e);
			}
		}
		
		$scope.closeIndvSuggestionModal = function(){
			$scope.indvSuggestionModal.hide();
		}
		
		$scope.$on('$destroy', function() {
			try{$scope.indvSuggestionModal.remove();}catch(e){}			
		});
	
	
		$scope.$on("initMultiSuggestionCtrl", function (event, args) {
			$scope.initMultiSuggestionCtrl();
		});
	
		
		
}]);

controllers.controller('indvSuggestionCtrl', ['$scope', '$state', '$http', '$ionicSlideBoxDelegate','$ionicScrollDelegate','$timeout','$ionicLoading','$ionicModal','$ionicPopup',
	
	function($scope, $state, $http, $ionicSlideBoxDelegate, $ionicScrollDelegate, $timeout, $ionicLoading, $ionicModal,$ionicPopup) {
	
		
		
		
		$scope.submitNewSuggestion = function(){
			if ($scope.newSugg.comments == '') return;
			if ($scope.newSugg.reqType == '') return;
			
			$ionicScrollDelegate.scrollBottom(true);
			getHTTPRequest( imgRootURL + 'executeService?service=suggestionReq&calledFor=I&createdBy='+ appUser.user.username+'&reqId='+ $scope.newSugg.reqId
											+'&reqType='+$scope.newSugg.reqType+'&comments='+$scope.newSugg.comments,
						    function(data) {
								if (data == 'null') return;
								var value = data[0];
								
								if (value.createdBy == 'admin'){
									value.author = 'admin';
								}else{
									value.author = 'me';
									value.authrPropPic = appUser.user.profPicSrc;	
									$ionicLoading.show({template: 'Thanks for your feedback', duration: 1500});
								}
								$scope.suggestionsPerReq.push(value);
						
								$scope.allSuggestions.push(value);							
								
								if ($scope.newSugg.reqId == 0){								
									$scope.suggestions.push(value);
								}
								$scope.newSugg.reqId = value.reqId;
								$scope.newSugg.comments = '';
								
							}
						);
		}
	
		$scope.onFocusSuggComntTxt = function() {
		  $ionicScrollDelegate.scrollBottom(true);
		}
		
}]);			